/* $Id: glu.h,v 3.2 1998/07/26 01:36:27 brianp Exp $ */

/*
 * Mesa 3-D graphics library
 * Version:  3.0
 * Copyright (C) 1995-1998  Brian Paul
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* Amicall's for StormC-PPC */
#ifndef STORMPROTOS_GLU_SPROTOS_H
#define STORMPROTOS_GLU_SPROTOS_H

extern "library=gluppcBase" {

GLUAPI void APIENTRY gluLookAt( GLdouble eyex, GLdouble eyey, GLdouble eyez,
				GLdouble centerx, GLdouble centery,
				GLdouble centerz,
				GLdouble upx, GLdouble upy, GLdouble upz );


GLUAPI void APIENTRY gluOrtho2D( GLdouble left, GLdouble right,
				 GLdouble bottom, GLdouble top );


GLUAPI void APIENTRY gluPerspective( GLdouble fovy, GLdouble aspect,
				     GLdouble zNear, GLdouble zFar );


GLUAPI void APIENTRY gluPickMatrix( GLdouble x, GLdouble y,
				    GLdouble width, GLdouble height,
				    const GLint viewport[4] );

GLUAPI GLint APIENTRY gluProject( GLdouble objx, GLdouble objy, GLdouble objz,
				  const GLdouble modelMatrix[16],
				  const GLdouble projMatrix[16],
				  const GLint viewport[4],
				  GLdouble *winx, GLdouble *winy,
				  GLdouble *winz );

GLUAPI GLint APIENTRY gluUnProject( GLdouble winx, GLdouble winy,
				    GLdouble winz,
				    const GLdouble modelMatrix[16],
				    const GLdouble projMatrix[16],
				    const GLint viewport[4],
				    GLdouble *objx, GLdouble *objy,
				    GLdouble *objz );

GLUAPI const GLubyte* APIENTRY gluErrorString( GLenum errorCode );



/*
 *
 * Mipmapping and image scaling
 *
 */

GLUAPI GLint APIENTRY gluScaleImage( GLenum format,
				     GLint widthin, GLint heightin,
				     GLenum typein, const void *datain,
				     GLint widthout, GLint heightout,
				     GLenum typeout, void *dataout );

GLUAPI GLint APIENTRY gluBuild1DMipmaps( GLenum target, GLint components,
					 GLint width, GLenum format,
					 GLenum type, const void *data );

GLUAPI GLint APIENTRY gluBuild2DMipmaps( GLenum target, GLint components,
					 GLint width, GLint height,
					 GLenum format,
					 GLenum type, const void *data );



/*
 *
 * Quadrics
 *
 */

GLUAPI GLUquadricObj* APIENTRY gluNewQuadric( void );

GLUAPI void APIENTRY gluDeleteQuadric( GLUquadricObj *state );

GLUAPI void APIENTRY gluQuadricDrawStyle( GLUquadricObj *quadObject,
					  GLenum drawStyle );

GLUAPI void APIENTRY gluQuadricOrientation( GLUquadricObj *quadObject,
					    GLenum orientation );

GLUAPI void APIENTRY gluQuadricNormals( GLUquadricObj *quadObject,
					GLenum normals );

GLUAPI void APIENTRY gluQuadricTexture( GLUquadricObj *quadObject,
					GLboolean textureCoords );

GLUAPI void APIENTRY gluQuadricCallback( GLUquadricObj *qobj,
					 GLenum which, void (CALLBACK *fn)() );

GLUAPI void APIENTRY gluCylinder( GLUquadricObj *qobj,
				  GLdouble baseRadius,
				  GLdouble topRadius,
				  GLdouble height,
				  GLint slices, GLint stacks );

GLUAPI void APIENTRY gluSphere( GLUquadricObj *qobj,
				GLdouble radius, GLint slices, GLint stacks );

GLUAPI void APIENTRY gluDisk( GLUquadricObj *qobj,
			      GLdouble innerRadius, GLdouble outerRadius,
			      GLint slices, GLint loops );

GLUAPI void APIENTRY gluPartialDisk( GLUquadricObj *qobj, GLdouble innerRadius,
				     GLdouble outerRadius, GLint slices,
				     GLint loops, GLdouble startAngle,
				     GLdouble sweepAngle );



/*
 *
 * Nurbs
 *
 */

GLUAPI GLUnurbsObj* APIENTRY gluNewNurbsRenderer( void );

GLUAPI void APIENTRY gluDeleteNurbsRenderer( GLUnurbsObj *nobj );

GLUAPI void APIENTRY gluLoadSamplingMatrices( GLUnurbsObj *nobj,
					      const GLfloat modelMatrix[16],
					      const GLfloat projMatrix[16],
					      const GLint viewport[4] );

GLUAPI void APIENTRY gluNurbsProperty( GLUnurbsObj *nobj, GLenum property,
				       GLfloat value );

GLUAPI void APIENTRY gluGetNurbsProperty( GLUnurbsObj *nobj, GLenum property,
					  GLfloat *value );

GLUAPI void APIENTRY gluBeginCurve( GLUnurbsObj *nobj );

GLUAPI void APIENTRY gluEndCurve( GLUnurbsObj * nobj );

GLUAPI void APIENTRY gluNurbsCurve( GLUnurbsObj *nobj, GLint nknots,
				    GLfloat *knot, GLint stride,
				    GLfloat *ctlarray, GLint order,
				    GLenum type );

GLUAPI void APIENTRY gluBeginSurface( GLUnurbsObj *nobj );

GLUAPI void APIENTRY gluEndSurface( GLUnurbsObj * nobj );

GLUAPI void APIENTRY gluNurbsSurface( GLUnurbsObj *nobj,
				      GLint sknot_count, GLfloat *sknot,
				      GLint tknot_count, GLfloat *tknot,
				      GLint s_stride, GLint t_stride,
				      GLfloat *ctlarray,
				      GLint sorder, GLint torder,
				      GLenum type );

GLUAPI void APIENTRY gluBeginTrim( GLUnurbsObj *nobj );

GLUAPI void APIENTRY gluEndTrim( GLUnurbsObj *nobj );

GLUAPI void APIENTRY gluPwlCurve( GLUnurbsObj *nobj, GLint count,
				  GLfloat *array, GLint stride, GLenum type );

GLUAPI void APIENTRY gluNurbsCallback( GLUnurbsObj *nobj, GLenum which,
				       void (CALLBACK *fn)() );



/*
 *
 * Polygon tesselation
 *
 */

GLUAPI GLUtriangulatorObj* APIENTRY gluNewTess( void );

GLUAPI void APIENTRY gluTessCallback( GLUtriangulatorObj *tobj, GLenum which,
				      void (CALLBACK *fn)() );

GLUAPI void APIENTRY gluDeleteTess( GLUtriangulatorObj *tobj );

GLUAPI void APIENTRY gluBeginPolygon( GLUtriangulatorObj *tobj );

GLUAPI void APIENTRY gluEndPolygon( GLUtriangulatorObj *tobj );

GLUAPI void APIENTRY gluNextContour( GLUtriangulatorObj *tobj, GLenum type );

GLUAPI void APIENTRY gluTessVertex( GLUtriangulatorObj *tobj, GLdouble v[3],
				    void *data );



/*
 *
 * New functions in GLU 1.1
 *
 */

GLUAPI const GLubyte* APIENTRY gluGetString( GLenum name );

};

#endif
