                include gl_lib.i
                fpu
                far

INIT            macro
                link    a5,#0
                movem.l a4-a6,-(sp)
                add.l   #8,a5
                move.l  _glBase,a6
                add.l   a6,a0
                move.l  a0,a4
                endm

EXIT            macro
                movem.l (sp)+,a4-a6
                unlk    a5
                rts
                endm

CALLFUNC        macro
                jsr     0(a4)
                endm

CALLFUNCQ       macro
                move.l  a6,-(sp)
                move.l  _glBase,a6
                jsr     0(a6,a0.l)
                move.l  (sp)+,a6
                rts
                endm

GETM_LONG       macro
                movem.l (a5)+,\1
                endm

* GETM_WORD       macro
*                 movem.w (a5)+,\1
*                 endm

GETFLOAT        macro
                fmove.s (a5)+,\1
                endm

GETDOUBLE       macro
                fmove.d (a5)+,\1
                endm

GETLONG         macro
                move.l  (a5)+,\1
                endm

GETWORD         macro
                addq    #2,a5
                move.w  (a5)+,\1
                endm

GETBYTE         macro
                addq.l  #3,a5
                move.b  (a5)+,\1
                endm

GETTAGS         macro
                move.l  a5,\1
                endm

PUSH            macro
                movem.l \1,-(sp)
                endm

PUSHF           macro
                fmovem.x        \1,-(sp)
                endm

POP             macro
                movem.l (sp)+,\1
                endm

POPF            macro
                fmovem.x        (sp)+,\1
                endm

CALL            macro
_\1
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

CALLD           macro
_\1
                move.l  a6,-(sp)
                move.l  _glBase,a6
                jsr     _LVO\1(a6)
                move.l  (sp)+,a6
                rts
                endm

CALLT           macro
_\1Tags
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

                XREF    _glBase

                XDEF    _registerGL
                XDEF    _AmigaMesaCreateContext
                XDEF    _AmigaMesaCreateContextTags
                XDEF    _AmigaMesaDestroyContext
                XDEF    _AmigaMesaCreateVisual
                XDEF    _AmigaMesaCreateVisualTags
                XDEF    _AmigaMesaDestroyVisual
                XDEF    _AmigaMesaMakeCurrent
                XDEF    _AmigaMesaSwapBuffers
                XDEF    _AmigaMesaSetOneColor
                XDEF    _AmigaMesaSetRast
                XDEF    _AmigaMesaSetRastTags
                XDEF    _AmigaMesaGetConfig
                XDEF    _glClearIndex
                XDEF    _glClearColor
                XDEF    _glClear
                XDEF    _glIndexMask
                XDEF    _glColorMask
                XDEF    _glAlphaFunc
                XDEF    _glBlendFunc
                XDEF    _glLogicOp
                XDEF    _glCullFace
                XDEF    _glFrontFace
                XDEF    _glPointSize
                XDEF    _glLineWidth
                XDEF    _glLineStipple
                XDEF    _glPolygonMode
                XDEF    _glPolygonOffset
                XDEF    _glPolygonStipple
                XDEF    _glGetPolygonStipple
                XDEF    _glEdgeFlag
                XDEF    _glEdgeFlagv
                XDEF    _glScissor
                XDEF    _glClipPlane
                XDEF    _glGetClipPlane
                XDEF    _glDrawBuffer
                XDEF    _glReadBuffer
                XDEF    _glEnable
                XDEF    _glDisable
                XDEF    _glIsEnabled
                XDEF    _glEnableClientState
                XDEF    _glDisableClientState
                XDEF    _glGetBooleanv
                XDEF    _glGetDoublev
                XDEF    _glGetFloatv
                XDEF    _glGetIntegerv
                XDEF    _glPushAttrib
                XDEF    _glPopAttrib
                XDEF    _glPushClientAttrib
                XDEF    _glPopClientAttrib
                XDEF    _glRenderMode
                XDEF    _glGetError
                XDEF    _glGetString
                XDEF    _glFinish
                XDEF    _glFlush
                XDEF    _glHint
                XDEF    _glClearDepth
                XDEF    _glDepthFunc
                XDEF    _glDepthMask
                XDEF    _glDepthRange
                XDEF    _glClearAccum
                XDEF    _glAccum
                XDEF    _glMatrixMode
                XDEF    _glOrtho
                XDEF    _glFrustum
                XDEF    _glViewport
                XDEF    _glPushMatrix
                XDEF    _glPopMatrix
                XDEF    _glLoadIdentity
                XDEF    _glLoadMatrixd
                XDEF    _glLoadMatrixf
                XDEF    _glMultMatrixd
                XDEF    _glMultMatrixf
                XDEF    _glRotated
                XDEF    _glRotatef
                XDEF    _glScaled
                XDEF    _glScalef
                XDEF    _glTranslated
                XDEF    _glTranslatef
                XDEF    _glIsList
                XDEF    _glDeleteLists
                XDEF    _glGenLists
                XDEF    _glNewList
                XDEF    _glEndList
                XDEF    _glCallList
                XDEF    _glCallLists
                XDEF    _glListBase
                XDEF    _glBegin
                XDEF    _glEnd
                XDEF    _glVertex2d
                XDEF    _glVertex2f
                XDEF    _glVertex2i
                XDEF    _glVertex2s
                XDEF    _glVertex3d
                XDEF    _glVertex3f
                XDEF    _glVertex3i
                XDEF    _glVertex3s
                XDEF    _glVertex4d
                XDEF    _glVertex4f
                XDEF    _glVertex4i
                XDEF    _glVertex4s
                XDEF    _glVertex2dv
                XDEF    _glVertex2fv
                XDEF    _glVertex2iv
                XDEF    _glVertex2sv
                XDEF    _glVertex3dv
                XDEF    _glVertex3fv
                XDEF    _glVertex3iv
                XDEF    _glVertex3sv
                XDEF    _glVertex4dv
                XDEF    _glVertex4fv
                XDEF    _glVertex4iv
                XDEF    _glVertex4sv
                XDEF    _glNormal3b
                XDEF    _glNormal3d
                XDEF    _glNormal3f
                XDEF    _glNormal3i
                XDEF    _glNormal3s
                XDEF    _glNormal3bv
                XDEF    _glNormal3dv
                XDEF    _glNormal3fv
                XDEF    _glNormal3iv
                XDEF    _glNormal3sv
                XDEF    _glIndexd
                XDEF    _glIndexf
                XDEF    _glIndexi
                XDEF    _glIndexs
                XDEF    _glIndexub
                XDEF    _glIndexdv
                XDEF    _glIndexfv
                XDEF    _glIndexiv
                XDEF    _glIndexsv
                XDEF    _glIndexubv
                XDEF    _glColor3b
                XDEF    _glColor3d
                XDEF    _glColor3f
                XDEF    _glColor3i
                XDEF    _glColor3s
                XDEF    _glColor3ub
                XDEF    _glColor3ui
                XDEF    _glColor3us
                XDEF    _glColor4b
                XDEF    _glColor4d
                XDEF    _glColor4f
                XDEF    _glColor4i
                XDEF    _glColor4s
                XDEF    _glColor4ub
                XDEF    _glColor4ui
                XDEF    _glColor4us
                XDEF    _glColor3bv
                XDEF    _glColor3dv
                XDEF    _glColor3fv
                XDEF    _glColor3iv
                XDEF    _glColor3sv
                XDEF    _glColor3ubv
                XDEF    _glColor3uiv
                XDEF    _glColor3usv
                XDEF    _glColor4bv
                XDEF    _glColor4dv
                XDEF    _glColor4fv
                XDEF    _glColor4iv
                XDEF    _glColor4sv
                XDEF    _glColor4ubv
                XDEF    _glColor4uiv
                XDEF    _glColor4usv
                XDEF    _glTexCoord1d
                XDEF    _glTexCoord1f
                XDEF    _glTexCoord1i
                XDEF    _glTexCoord1s
                XDEF    _glTexCoord2d
                XDEF    _glTexCoord2f
                XDEF    _glTexCoord2i
                XDEF    _glTexCoord2s
                XDEF    _glTexCoord3d
                XDEF    _glTexCoord3f
                XDEF    _glTexCoord3i
                XDEF    _glTexCoord3s
                XDEF    _glTexCoord4d
                XDEF    _glTexCoord4f
                XDEF    _glTexCoord4i
                XDEF    _glTexCoord4s
                XDEF    _glTexCoord1dv
                XDEF    _glTexCoord1fv
                XDEF    _glTexCoord1iv
                XDEF    _glTexCoord1sv
                XDEF    _glTexCoord2dv
                XDEF    _glTexCoord2fv
                XDEF    _glTexCoord2iv
                XDEF    _glTexCoord2sv
                XDEF    _glTexCoord3dv
                XDEF    _glTexCoord3fv
                XDEF    _glTexCoord3iv
                XDEF    _glTexCoord3sv
                XDEF    _glTexCoord4dv
                XDEF    _glTexCoord4fv
                XDEF    _glTexCoord4iv
                XDEF    _glTexCoord4sv
                XDEF    _glRasterPos2d
                XDEF    _glRasterPos2f
                XDEF    _glRasterPos2i
                XDEF    _glRasterPos2s
                XDEF    _glRasterPos3d
                XDEF    _glRasterPos3f
                XDEF    _glRasterPos3i
                XDEF    _glRasterPos3s
                XDEF    _glRasterPos4d
                XDEF    _glRasterPos4f
                XDEF    _glRasterPos4i
                XDEF    _glRasterPos4s
                XDEF    _glRasterPos2dv
                XDEF    _glRasterPos2fv
                XDEF    _glRasterPos2iv
                XDEF    _glRasterPos2sv
                XDEF    _glRasterPos3dv
                XDEF    _glRasterPos3fv
                XDEF    _glRasterPos3iv
                XDEF    _glRasterPos3sv
                XDEF    _glRasterPos4dv
                XDEF    _glRasterPos4fv
                XDEF    _glRasterPos4iv
                XDEF    _glRasterPos4sv
                XDEF    _glRectd
                XDEF    _glRectf
                XDEF    _glRecti
                XDEF    _glRects
                XDEF    _glRectdv
                XDEF    _glRectfv
                XDEF    _glRectiv
                XDEF    _glRectsv
                XDEF    _glVertexPointer
                XDEF    _glNormalPointer
                XDEF    _glColorPointer
                XDEF    _glIndexPointer
                XDEF    _glTexCoordPointer
                XDEF    _glEdgeFlagPointer
                XDEF    _glGetPointerv
                XDEF    _glArrayElement
                XDEF    _glDrawArrays
                XDEF    _glDrawElements
                XDEF    _glInterleavedArrays
                XDEF    _glShadeModel
                XDEF    _glLightf
                XDEF    _glLighti
                XDEF    _glLightfv
                XDEF    _glLightiv
                XDEF    _glGetLightfv
                XDEF    _glGetLightiv
                XDEF    _glLightModelf
                XDEF    _glLightModeli
                XDEF    _glLightModelfv
                XDEF    _glLightModeliv
                XDEF    _glMaterialf
                XDEF    _glMateriali
                XDEF    _glMaterialfv
                XDEF    _glMaterialiv
                XDEF    _glGetMaterialfv
                XDEF    _glGetMaterialiv
                XDEF    _glColorMaterial
                XDEF    _glPixelZoom
                XDEF    _glPixelStoref
                XDEF    _glPixelStorei
                XDEF    _glPixelTransferf
                XDEF    _glPixelTransferi
                XDEF    _glPixelMapfv
                XDEF    _glPixelMapuiv
                XDEF    _glPixelMapusv
                XDEF    _glGetPixelMapfv
                XDEF    _glGetPixelMapuiv
                XDEF    _glGetPixelMapusv
                XDEF    _glBitmap
                XDEF    _glReadPixels
                XDEF    _glDrawPixels
                XDEF    _glCopyPixels
                XDEF    _glStencilFunc
                XDEF    _glStencilMask
                XDEF    _glStencilOp
                XDEF    _glClearStencil
                XDEF    _glTexGend
                XDEF    _glTexGenf
                XDEF    _glTexGeni
                XDEF    _glTexGendv
                XDEF    _glTexGenfv
                XDEF    _glTexGeniv
                XDEF    _glGetTexGendv
                XDEF    _glGetTexGenfv
                XDEF    _glGetTexGeniv
                XDEF    _glTexEnvf
                XDEF    _glTexEnvi
                XDEF    _glTexEnvfv
                XDEF    _glTexEnviv
                XDEF    _glGetTexEnvfv
                XDEF    _glGetTexEnviv
                XDEF    _glTexParameterf
                XDEF    _glTexParameteri
                XDEF    _glTexParameterfv
                XDEF    _glTexParameteriv
                XDEF    _glGetTexParameterfv
                XDEF    _glGetTexParameteriv
                XDEF    _glGetTexLevelParameterfv
                XDEF    _glGetTexLevelParameteriv
                XDEF    _glTexImage1D
                XDEF    _glTexImage2D
                XDEF    _glGetTexImage
                XDEF    _glGenTextures
                XDEF    _glDeleteTextures
                XDEF    _glBindTexture
                XDEF    _glPrioritizeTextures
                XDEF    _glAreTexturesResident
                XDEF    _glIsTexture
                XDEF    _glTexSubImage1D
                XDEF    _glTexSubImage2D
                XDEF    _glCopyTexImage1D
                XDEF    _glCopyTexImage2D
                XDEF    _glCopyTexSubImage1D
                XDEF    _glCopyTexSubImage2D
                XDEF    _glMap1d
                XDEF    _glMap1f
                XDEF    _glMap2d
                XDEF    _glMap2f
                XDEF    _glGetMapdv
                XDEF    _glGetMapfv
                XDEF    _glGetMapiv
                XDEF    _glEvalCoord1d
                XDEF    _glEvalCoord1f
                XDEF    _glEvalCoord1dv
                XDEF    _glEvalCoord1fv
                XDEF    _glEvalCoord2d
                XDEF    _glEvalCoord2f
                XDEF    _glEvalCoord2dv
                XDEF    _glEvalCoord2fv
                XDEF    _glMapGrid1d
                XDEF    _glMapGrid1f
                XDEF    _glMapGrid2d
                XDEF    _glMapGrid2f
                XDEF    _glEvalPoint1
                XDEF    _glEvalPoint2
                XDEF    _glEvalMesh1
                XDEF    _glEvalMesh2
                XDEF    _glFogf
                XDEF    _glFogi
                XDEF    _glFogfv
                XDEF    _glFogiv
                XDEF    _glFeedbackBuffer
                XDEF    _glPassThrough
                XDEF    _glSelectBuffer
                XDEF    _glInitNames
                XDEF    _glLoadName
                XDEF    _glPushName
                XDEF    _glPopName
                XDEF    _glBlendEquationEXT
                XDEF    _glBlendColorEXT
                XDEF    _glPolygonOffsetEXT
                XDEF    _glVertexPointerEXT
                XDEF    _glNormalPointerEXT
                XDEF    _glColorPointerEXT
                XDEF    _glIndexPointerEXT
                XDEF    _glTexCoordPointerEXT
                XDEF    _glEdgeFlagPointerEXT
                XDEF    _glGetPointervEXT
                XDEF    _glArrayElementEXT
                XDEF    _glDrawArraysEXT
                XDEF    _glGenTexturesEXT
                XDEF    _glDeleteTexturesEXT
                XDEF    _glBindTextureEXT
                XDEF    _glPrioritizeTexturesEXT
                XDEF    _glAreTexturesResidentEXT
                XDEF    _glIsTextureEXT
                XDEF    _glTexImage3DEXT
                XDEF    _glTexSubImage3DEXT
                XDEF    _glCopyTexSubImage3DEXT
                XDEF    _glColorTableEXT
                XDEF    _glColorSubTableEXT
                XDEF    _glGetColorTableEXT
                XDEF    _glGetColorTableParameterfvEXT
                XDEF    _glGetColorTableParameterivEXT
                XDEF    _glMultiTexCoord1dSGIS
                XDEF    _glMultiTexCoord1dvSGIS
                XDEF    _glMultiTexCoord1fSGIS
                XDEF    _glMultiTexCoord1fvSGIS
                XDEF    _glMultiTexCoord1iSGIS
                XDEF    _glMultiTexCoord1ivSGIS
                XDEF    _glMultiTexCoord1sSGIS
                XDEF    _glMultiTexCoord1svSGIS
                XDEF    _glMultiTexCoord2dSGIS
                XDEF    _glMultiTexCoord2dvSGIS
                XDEF    _glMultiTexCoord2fSGIS
                XDEF    _glMultiTexCoord2fvSGIS
                XDEF    _glMultiTexCoord2iSGIS
                XDEF    _glMultiTexCoord2ivSGIS
                XDEF    _glMultiTexCoord2sSGIS
                XDEF    _glMultiTexCoord2svSGIS
                XDEF    _glMultiTexCoord3dSGIS
                XDEF    _glMultiTexCoord3dvSGIS
                XDEF    _glMultiTexCoord3fSGIS
                XDEF    _glMultiTexCoord3fvSGIS
                XDEF    _glMultiTexCoord3iSGIS
                XDEF    _glMultiTexCoord3ivSGIS
                XDEF    _glMultiTexCoord3sSGIS
                XDEF    _glMultiTexCoord3svSGIS
                XDEF    _glMultiTexCoord4dSGIS
                XDEF    _glMultiTexCoord4dvSGIS
                XDEF    _glMultiTexCoord4fSGIS
                XDEF    _glMultiTexCoord4fvSGIS
                XDEF    _glMultiTexCoord4iSGIS
                XDEF    _glMultiTexCoord4ivSGIS
                XDEF    _glMultiTexCoord4sSGIS
                XDEF    _glMultiTexCoord4svSGIS
                XDEF    _glMultiTexCoordPointerSGIS
                XDEF    _glSelectTextureSGIS
                XDEF    _glSelectTextureCoordSetSGIS
                XDEF    _glMultiTexCoord1dEXT
                XDEF    _glMultiTexCoord1dvEXT
                XDEF    _glMultiTexCoord1fEXT
                XDEF    _glMultiTexCoord1fvEXT
                XDEF    _glMultiTexCoord1iEXT
                XDEF    _glMultiTexCoord1ivEXT
                XDEF    _glMultiTexCoord1sEXT
                XDEF    _glMultiTexCoord1svEXT
                XDEF    _glMultiTexCoord2dEXT
                XDEF    _glMultiTexCoord2dvEXT
                XDEF    _glMultiTexCoord2fEXT
                XDEF    _glMultiTexCoord2fvEXT
                XDEF    _glMultiTexCoord2iEXT
                XDEF    _glMultiTexCoord2ivEXT
                XDEF    _glMultiTexCoord2sEXT
                XDEF    _glMultiTexCoord2svEXT
                XDEF    _glMultiTexCoord3dEXT
                XDEF    _glMultiTexCoord3dvEXT
                XDEF    _glMultiTexCoord3fEXT
                XDEF    _glMultiTexCoord3fvEXT
                XDEF    _glMultiTexCoord3iEXT
                XDEF    _glMultiTexCoord3ivEXT
                XDEF    _glMultiTexCoord3sEXT
                XDEF    _glMultiTexCoord3svEXT
                XDEF    _glMultiTexCoord4dEXT
                XDEF    _glMultiTexCoord4dvEXT
                XDEF    _glMultiTexCoord4fEXT
                XDEF    _glMultiTexCoord4fvEXT
                XDEF    _glMultiTexCoord4iEXT
                XDEF    _glMultiTexCoord4ivEXT
                XDEF    _glMultiTexCoord4sEXT
                XDEF    _glMultiTexCoord4svEXT
                XDEF    _glInterleavedTextureCoordSetsEXT
                XDEF    _glSelectTextureEXT
                XDEF    _glSelectTextureCoordSetEXT
                XDEF    _glSelectTextureTransformEXT
                XDEF    _glPointParameterfEXT
                XDEF    _glPointParameterfvEXT
                XDEF    _glWindowPos2iMESA
                XDEF    _glWindowPos2sMESA
                XDEF    _glWindowPos2fMESA
                XDEF    _glWindowPos2dMESA
                XDEF    _glWindowPos2ivMESA
                XDEF    _glWindowPos2svMESA
                XDEF    _glWindowPos2fvMESA
                XDEF    _glWindowPos2dvMESA
                XDEF    _glWindowPos3iMESA
                XDEF    _glWindowPos3sMESA
                XDEF    _glWindowPos3fMESA
                XDEF    _glWindowPos3dMESA
                XDEF    _glWindowPos3ivMESA
                XDEF    _glWindowPos3svMESA
                XDEF    _glWindowPos3fvMESA
                XDEF    _glWindowPos3dvMESA
                XDEF    _glWindowPos4iMESA
                XDEF    _glWindowPos4sMESA
                XDEF    _glWindowPos4fMESA
                XDEF    _glWindowPos4dMESA
                XDEF    _glWindowPos4ivMESA
                XDEF    _glWindowPos4svMESA
                XDEF    _glWindowPos4fvMESA
                XDEF    _glWindowPos4dvMESA
                XDEF    _glResizeBuffersMESA
                XDEF    _glDrawRangeElements
                XDEF    _glTexImage3D
                XDEF    _glTexSubImage3D
                XDEF    _glCopyTexSubImage3D



                section "glStubs",code

                CALLD   registerGL
                CALLD   AmigaMesaCreateContext
                CALLT   AmigaMesaCreateContext,tags_a0
                CALLD   AmigaMesaDestroyContext
                CALLD   AmigaMesaCreateVisual
                CALLT   AmigaMesaCreateVisual,tags_a0
                CALLD   AmigaMesaDestroyVisual
                CALLD   AmigaMesaMakeCurrent
                CALLD   AmigaMesaSwapBuffers
                CALLD   AmigaMesaSetOneColor
                CALLD   AmigaMesaSetRast
                CALLT   AmigaMesaSetRast,a0_tags_a1
                CALLD   AmigaMesaGetConfig
                CALL    glClearIndex,fp0
                CALL    glClearColor,fp0_fp3
                CALL    glClear,d0
                CALL    glIndexMask,d0
                CALL    glColorMask,bd0_bd3
                CALL    glAlphaFunc,d0_fp0
                CALL    glBlendFunc,d0_d1
                CALL    glLogicOp,d0
                CALL    glCullFace,d0
                CALL    glFrontFace,d0
                CALL    glPointSize,fp0
                CALL    glLineWidth,fp0
                CALL    glLineStipple,d0_wd1
                CALL    glPolygonMode,d0_d1
                CALL    glPolygonOffset,fp0_fp1
                CALL    glPolygonStipple,a0
                CALL    glGetPolygonStipple,a0
                CALL    glEdgeFlag,bd0
                CALL    glEdgeFlagv,d0
                CALL    glScissor,d0_d3
                CALL    glClipPlane,d0_a0
                CALL    glGetClipPlane,d0_a0
                CALL    glDrawBuffer,d0
                CALL    glReadBuffer,d0
                CALL    glEnable,d0
                CALL    glDisable,d0
                CALL    glIsEnabled,d0
                CALL    glEnableClientState,d0
                CALL    glDisableClientState,d0
                CALL    glGetBooleanv,d0_a0
                CALL    glGetDoublev,d0_a0
                CALL    glGetFloatv,d0_a0
                CALL    glGetIntegerv,d0_a0
                CALL    glPushAttrib,d0
                CALL    glPopAttrib,void
                CALL    glPushClientAttrib,d0
                CALL    glPopClientAttrib,void
                CALL    glRenderMode,d0
                CALL    glGetError,void
                CALL    glGetString,d0
                CALL    glFinish,void
                CALL    glFlush,void
                CALL    glHint,d0_d1
                CALL    glClearDepth,dfp0
                CALL    glDepthFunc,d0
                CALL    glDepthMask,bd0
                CALL    glDepthRange,dfp0_dfp1
                CALL    glClearAccum,fp0_fp3
                CALL    glAccum,d0_fp0
                CALL    glMatrixMode,d0
                CALL    glOrtho,dfp0_dfp5
                CALL    glFrustum,dfp0_dfp5
                CALL    glViewport,d0_d3
                CALL    glPushMatrix,void
                CALL    glPopMatrix,void
                CALL    glLoadIdentity,void
                CALL    glLoadMatrixd,a0
                CALL    glLoadMatrixf,a0
                CALL    glMultMatrixd,a0
                CALL    glMultMatrixf,a0
                CALL    glRotated,dfp0_dfp3
                CALL    glRotatef,fp0_fp3
                CALL    glScaled,dfp0_dfp2
                CALL    glScalef,fp0_fp2
                CALL    glTranslated,dfp0_dfp2
                CALL    glTranslatef,fp0_fp2
                CALL    glIsList,d0
                CALL    glDeleteLists,d0_d1
                CALL    glGenLists,d0
                CALL    glNewList,d0_d1
                CALL    glEndList,void
                CALL    glCallList,d0
                CALL    glCallLists,d0_d1_a0
                CALL    glListBase,d0
                CALL    glBegin,d0
                CALL    glEnd,void
                CALL    glVertex2d,dfp0_dfp1
                CALL    glVertex2f,fp0_fp1
                CALL    glVertex2i,d0_d1
                CALL    glVertex2s,wd0_wd1
                CALL    glVertex3d,dfp0_dfp2
                CALL    glVertex3f,fp0_fp2
                CALL    glVertex3i,d0_d2
                CALL    glVertex3s,wd0_wd2
                CALL    glVertex4d,dfp0_dfp3
                CALL    glVertex4f,fp0_fp3
                CALL    glVertex4i,d0_d3
                CALL    glVertex4s,wd0_wd3
                CALL    glVertex2dv,a0
                CALL    glVertex2fv,a0
                CALL    glVertex2iv,a0
                CALL    glVertex2sv,a0
                CALL    glVertex3dv,a0
                CALL    glVertex3fv,a0
                CALL    glVertex3iv,a0
                CALL    glVertex3sv,a0
                CALL    glVertex4dv,a0
                CALL    glVertex4fv,a0
                CALL    glVertex4iv,a0
                CALL    glVertex4sv,a0
                CALL    glNormal3b,bd0_bd2
                CALL    glNormal3d,dfp0_dfp2
                CALL    glNormal3f,fp0_fp2
                CALL    glNormal3i,d0_d2
                CALL    glNormal3s,wd0_wd2
                CALL    glNormal3bv,a0
                CALL    glNormal3dv,a0
                CALL    glNormal3fv,a0
                CALL    glNormal3iv,a0
                CALL    glNormal3sv,a0
                CALL    glIndexd,dfp0
                CALL    glIndexf,fp0
                CALL    glIndexi,d0
                CALL    glIndexs,wd0
                CALL    glIndexub,bd0
                CALL    glIndexdv,a0
                CALL    glIndexfv,a0
                CALL    glIndexiv,a0
                CALL    glIndexsv,a0
                CALL    glIndexubv,a0
                CALL    glColor3b,bd0_bd2
                CALL    glColor3d,dfp0_dfp2
                CALL    glColor3f,fp0_fp2
                CALL    glColor3i,d0_d2
                CALL    glColor3s,wd0_wd2
                CALL    glColor3ub,bd0_bd2
                CALL    glColor3ui,d0_d2
                CALL    glColor3us,wd0_wd2
                CALL    glColor4b,bd0_bd3
                CALL    glColor4d,dfp0_dfp3
                CALL    glColor4f,fp0_fp3
                CALL    glColor4i,d0_d3
                CALL    glColor4s,wd0_wd3
                CALL    glColor4ub,bd0_bd3
                CALL    glColor4ui,d0_d3
                CALL    glColor4us,wd0_wd3
                CALL    glColor3bv,a0
                CALL    glColor3dv,a0
                CALL    glColor3fv,a0
                CALL    glColor3iv,a0
                CALL    glColor3sv,a0
                CALL    glColor3ubv,a0
                CALL    glColor3uiv,a0
                CALL    glColor3usv,a0
                CALL    glColor4bv,a0
                CALL    glColor4dv,a0
                CALL    glColor4fv,a0
                CALL    glColor4iv,a0
                CALL    glColor4sv,a0
                CALL    glColor4ubv,a0
                CALL    glColor4uiv,a0
                CALL    glColor4usv,a0
                CALL    glTexCoord1d,dfp0
                CALL    glTexCoord1f,fp0
                CALL    glTexCoord1i,d0
                CALL    glTexCoord1s,wd0
                CALL    glTexCoord2d,dfp0_dfp1
                CALL    glTexCoord2f,fp0_fp1
                CALL    glTexCoord2i,d0_d1
                CALL    glTexCoord2s,wd0_wd1
                CALL    glTexCoord3d,dfp0_dfp2
                CALL    glTexCoord3f,fp0_fp2
                CALL    glTexCoord3i,d0_d2
                CALL    glTexCoord3s,wd0_wd2
                CALL    glTexCoord4d,dfp0_dfp3
                CALL    glTexCoord4f,fp0_fp3
                CALL    glTexCoord4i,d0_d3
                CALL    glTexCoord4s,wd0_wd3
                CALL    glTexCoord1dv,a0
                CALL    glTexCoord1fv,a0
                CALL    glTexCoord1iv,a0
                CALL    glTexCoord1sv,a0
                CALL    glTexCoord2dv,a0
                CALL    glTexCoord2fv,a0
                CALL    glTexCoord2iv,a0
                CALL    glTexCoord2sv,a0
                CALL    glTexCoord3dv,a0
                CALL    glTexCoord3fv,a0
                CALL    glTexCoord3iv,a0
                CALL    glTexCoord3sv,a0
                CALL    glTexCoord4dv,a0
                CALL    glTexCoord4fv,a0
                CALL    glTexCoord4iv,a0
                CALL    glTexCoord4sv,a0
                CALL    glRasterPos2d,dfp0_dfp1
                CALL    glRasterPos2f,fp0_fp1
                CALL    glRasterPos2i,d0_d1
                CALL    glRasterPos2s,wd0_wd1
                CALL    glRasterPos3d,dfp0_dfp2
                CALL    glRasterPos3f,fp0_fp2
                CALL    glRasterPos3i,d0_d2
                CALL    glRasterPos3s,wd0_wd2
                CALL    glRasterPos4d,dfp0_dfp3
                CALL    glRasterPos4f,fp0_fp3
                CALL    glRasterPos4i,d0_d3
                CALL    glRasterPos4s,wd0_wd3
                CALL    glRasterPos2dv,a0
                CALL    glRasterPos2fv,a0
                CALL    glRasterPos2iv,a0
                CALL    glRasterPos2sv,a0
                CALL    glRasterPos3dv,a0
                CALL    glRasterPos3fv,a0
                CALL    glRasterPos3iv,a0
                CALL    glRasterPos3sv,a0
                CALL    glRasterPos4dv,a0
                CALL    glRasterPos4fv,a0
                CALL    glRasterPos4iv,a0
                CALL    glRasterPos4sv,a0
                CALL    glRectd,dfp0_dfp3
                CALL    glRectf,fp0_fp3
                CALL    glRecti,d0_d3
                CALL    glRects,wd0_wd3
                CALL    glRectdv,a0_a1
                CALL    glRectfv,a0_a1
                CALL    glRectiv,a0_a1
                CALL    glRectsv,a0_a1
                CALL    glVertexPointer,d0_d2_a0
                CALL    glNormalPointer,d0_d1_a0
                CALL    glColorPointer,d0_d2_a0
                CALL    glIndexPointer,d0_d1_a0
                CALL    glTexCoordPointer,d0_d2_a0
                CALL    glEdgeFlagPointer,d0_a0
                CALL    glGetPointerv,d0_a0
                CALL    glArrayElement,d0
                CALL    glDrawArrays,d0_d2
                CALL    glDrawElements,d0_d2_a0
                CALL    glInterleavedArrays,d0_d1_a0
                CALL    glShadeModel,d0
                CALL    glLightf,d0_d1_fp0
                CALL    glLighti,d0_d2
                CALL    glLightfv,d0_d1_a0
                CALL    glLightiv,d0_d1_a0
                CALL    glGetLightfv,d0_d1_a0
                CALL    glGetLightiv,d0_d1_a0
                CALL    glLightModelf,d0_fp0
                CALL    glLightModeli,d0_d1
                CALL    glLightModelfv,d0_a0
                CALL    glLightModeliv,d0_a0
                CALL    glMaterialf,d0_d1_fp0
                CALL    glMateriali,d0_d2
                CALL    glMaterialfv,d0_d1_a0
                CALL    glMaterialiv,d0_d1_a0
                CALL    glGetMaterialfv,d0_d1_a0
                CALL    glGetMaterialiv,d0_d1_a0
                CALL    glColorMaterial,d0_d1
                CALL    glPixelZoom,fp0_fp1
                CALL    glPixelStoref,d0_fp0
                CALL    glPixelStorei,d0_d1
                CALL    glPixelTransferf,d0_fp0
                CALL    glPixelTransferi,d0_d1
                CALL    glPixelMapfv,d0_d1_a0
                CALL    glPixelMapuiv,d0_d1_a0
                CALL    glPixelMapusv,d0_d1_a0
                CALL    glGetPixelMapfv,d0_a0
                CALL    glGetPixelMapuiv,d0_a0
                CALL    glGetPixelMapusv,d0_a0
                CALL    glBitmap,d0_d1_fp0_fp3_a0
                CALL    glReadPixels,d0_d5_a0
                CALL    glDrawPixels,d0_d3_a0
                CALL    glCopyPixels,d0_d4
                CALL    glStencilFunc,d0_d2
                CALL    glStencilMask,d0
                CALL    glStencilOp,d0_d2
                CALL    glClearStencil,d0
                CALL    glTexGend,d0_d1_dfp0
                CALL    glTexGenf,d0_d1_fp0
                CALL    glTexGeni,d0_d2
                CALL    glTexGendv,d0_d1_a0
                CALL    glTexGenfv,d0_d1_a0
                CALL    glTexGeniv,d0_d1_a0
                CALL    glGetTexGendv,d0_d1_a0
                CALL    glGetTexGenfv,d0_d1_a0
                CALL    glGetTexGeniv,d0_d1_a0
                CALL    glTexEnvf,d0_d1_fp0
                CALL    glTexEnvi,d0_d2
                CALL    glTexEnvfv,d0_d1_a0
                CALL    glTexEnviv,d0_d1_a0
                CALL    glGetTexEnvfv,d0_d1_a0
                CALL    glGetTexEnviv,d0_d1_a0
                CALL    glTexParameterf,d0_d1_fp0
                CALL    glTexParameteri,d0_d2
                CALL    glTexParameterfv,d0_d1_a0
                CALL    glTexParameteriv,d0_d1_a0
                CALL    glGetTexParameterfv,d0_d1_a0
                CALL    glGetTexParameteriv,d0_d1_a0
                CALL    glGetTexLevelParameterfv,d0_d2_a0
                CALL    glGetTexLevelParameteriv,d0_d2_a0
                CALL    glTexImage1D,d0_d6_a0
                CALL    glTexImage2D,d0_d7_a0
                CALL    glGetTexImage,d0_d3_a0
                CALL    glGenTextures,d0_a0
                CALL    glDeleteTextures,d0_a0
                CALL    glBindTexture,d0_d1
                CALL    glPrioritizeTextures,d0_a0_a1
                CALL    glAreTexturesResident,d0_a0_a1
                CALL    glIsTexture,d0
                CALL    glTexSubImage1D,d0_d5_a0
                CALL    glTexSubImage2D,d0_d7_a0
                CALL    glCopyTexImage1D,d0_d6
                CALL    glCopyTexImage2D,d0_d7
                CALL    glCopyTexSubImage1D,d0_d5
                CALL    glCopyTexSubImage2D,d0_d7
                CALL    glMap1d,d0_dfp0_dfp1_d1_d2_a0
                CALL    glMap1f,d0_fp0_fp1_d1_d2_a0
                CALL    glMap2d,d0_dfp0_dfp1_d1_d2_dfp2_dfp3_d3_d4_a0
                CALL    glMap2f,d0_fp0_fp1_d1_d2_fp2_fp3_d3_d4_a0
                CALL    glGetMapdv,d0_d1_a0
                CALL    glGetMapfv,d0_d1_a0
                CALL    glGetMapiv,d0_d1_a0
                CALL    glEvalCoord1d,dfp0
                CALL    glEvalCoord1f,fp0
                CALL    glEvalCoord1dv,a0
                CALL    glEvalCoord1fv,a0
                CALL    glEvalCoord2d,dfp0_dfp1
                CALL    glEvalCoord2f,fp0_fp1
                CALL    glEvalCoord2dv,a0
                CALL    glEvalCoord2fv,a0
                CALL    glMapGrid1d,d0_dfp0_dfp1
                CALL    glMapGrid1f,d0_fp0_fp1
                CALL    glMapGrid2d,d0_dfp0_dfp1_d1_dfp2_dfp3
                CALL    glMapGrid2f,d0_fp0_fp1_d1_fp2_fp3
                CALL    glEvalPoint1,d0
                CALL    glEvalPoint2,d0_d1
                CALL    glEvalMesh1,d0_d2
                CALL    glEvalMesh2,d0_d4
                CALL    glFogf,d0_fp0
                CALL    glFogi,d0_d1
                CALL    glFogfv,d0_a0
                CALL    glFogiv,d0_a0
                CALL    glFeedbackBuffer,d0_d1_a0
                CALL    glPassThrough,fp0
                CALL    glSelectBuffer,d0_a0
                CALL    glInitNames,void
                CALL    glLoadName,d0
                CALL    glPushName,d0
                CALL    glPopName,void
                CALL    glBlendEquationEXT,d0
                CALL    glBlendColorEXT,fp0_fp3
                CALL    glPolygonOffsetEXT,fp0_fp1
                CALL    glVertexPointerEXT,d0_d3_a0
                CALL    glNormalPointerEXT,d0_d2_a0
                CALL    glColorPointerEXT,d0_d3_a0
                CALL    glIndexPointerEXT,d0_d2_a0
                CALL    glTexCoordPointerEXT,d0_d3_a0
                CALL    glEdgeFlagPointerEXT,d0_d1_a0
                CALL    glGetPointervEXT,d0_a0
                CALL    glArrayElementEXT,d0
                CALL    glDrawArraysEXT,d0_d2
                CALL    glGenTexturesEXT,d0_a0
                CALL    glDeleteTexturesEXT,d0_a0
                CALL    glBindTextureEXT,d0_d1
                CALL    glPrioritizeTexturesEXT,d0_a0_a1
                CALL    glAreTexturesResidentEXT,d0_a0_a1
                CALL    glIsTextureEXT,d0
                CALL    glTexImage3DEXT,d0_d7_a0_a1
                CALL    glTexSubImage3DEXT,d0_d7_a0_a2
                CALL    glCopyTexSubImage3DEXT,d0_d7_a0
                CALL    glColorTableEXT,d0_d4_a0
                CALL    glColorSubTableEXT,d0_d4_a0
                CALL    glGetColorTableEXT,d0_d2_a0
                CALL    glGetColorTableParameterfvEXT,d0_d1_a0
                CALL    glGetColorTableParameterivEXT,d0_d1_a0
                CALL    glMultiTexCoord1dSGIS,d0_dfp0
                CALL    glMultiTexCoord1dvSGIS,d0_a0
                CALL    glMultiTexCoord1fSGIS,d0_fp0
                CALL    glMultiTexCoord1fvSGIS,d0_a0
                CALL    glMultiTexCoord1iSGIS,d0_d1
                CALL    glMultiTexCoord1ivSGIS,d0_a0
                CALL    glMultiTexCoord1sSGIS,d0_wd1
                CALL    glMultiTexCoord1svSGIS,d0_a0
                CALL    glMultiTexCoord2dSGIS,d0_dfp0_dfp1
                CALL    glMultiTexCoord2dvSGIS,d0_a0
                CALL    glMultiTexCoord2fSGIS,d0_fp0_fp1
                CALL    glMultiTexCoord2fvSGIS,d0_a0
                CALL    glMultiTexCoord2iSGIS,d0_d2
                CALL    glMultiTexCoord2ivSGIS,d0_a0
                CALL    glMultiTexCoord2sSGIS,d0_wd1_wd2
                CALL    glMultiTexCoord2svSGIS,d0_a0
                CALL    glMultiTexCoord3dSGIS,d0_dfp0_dfp2
                CALL    glMultiTexCoord3dvSGIS,d0_a0
                CALL    glMultiTexCoord3fSGIS,d0_fp0_fp2
                CALL    glMultiTexCoord3fvSGIS,d0_a0
                CALL    glMultiTexCoord3iSGIS,d0_d3
                CALL    glMultiTexCoord3ivSGIS,d0_a0
                CALL    glMultiTexCoord3sSGIS,d0_wd1_wd3
                CALL    glMultiTexCoord3svSGIS,d0_a0
                CALL    glMultiTexCoord4dSGIS,d0_dfp0_dfp3
                CALL    glMultiTexCoord4dvSGIS,d0_a0
                CALL    glMultiTexCoord4fSGIS,d0_fp0_fp3
                CALL    glMultiTexCoord4fvSGIS,d0_a0
                CALL    glMultiTexCoord4iSGIS,d0_d4
                CALL    glMultiTexCoord4ivSGIS,d0_a0
                CALL    glMultiTexCoord4sSGIS,d0_wd1_wd4
                CALL    glMultiTexCoord4svSGIS,d0_a0
                CALL    glMultiTexCoordPointerSGIS,d0_d3_a0
                CALL    glSelectTextureSGIS,d0
                CALL    glSelectTextureCoordSetSGIS,d0
                CALL    glMultiTexCoord1dEXT,d0_dfp0
                CALL    glMultiTexCoord1dvEXT,d0_a0
                CALL    glMultiTexCoord1fEXT,d0_fp0
                CALL    glMultiTexCoord1fvEXT,d0_a0
                CALL    glMultiTexCoord1iEXT,d0_d1
                CALL    glMultiTexCoord1ivEXT,d0_a0
                CALL    glMultiTexCoord1sEXT,d0_wd1
                CALL    glMultiTexCoord1svEXT,d0_a0
                CALL    glMultiTexCoord2dEXT,d0_dfp0_dfp1
                CALL    glMultiTexCoord2dvEXT,d0_a0
                CALL    glMultiTexCoord2fEXT,d0_fp0_fp1
                CALL    glMultiTexCoord2fvEXT,d0_a0
                CALL    glMultiTexCoord2iEXT,d0_d2
                CALL    glMultiTexCoord2ivEXT,d0_a0
                CALL    glMultiTexCoord2sEXT,d0_wd1_wd2
                CALL    glMultiTexCoord2svEXT,d0_a0
                CALL    glMultiTexCoord3dEXT,d0_dfp0_dfp2
                CALL    glMultiTexCoord3dvEXT,d0_a0
                CALL    glMultiTexCoord3fEXT,d0_fp0_fp2
                CALL    glMultiTexCoord3fvEXT,d0_a0
                CALL    glMultiTexCoord3iEXT,d0_d3
                CALL    glMultiTexCoord3ivEXT,d0_a0
                CALL    glMultiTexCoord3sEXT,d0_wd1_wd3
                CALL    glMultiTexCoord3svEXT,d0_a0
                CALL    glMultiTexCoord4dEXT,d0_dfp0_dfp3
                CALL    glMultiTexCoord4dvEXT,d0_a0
                CALL    glMultiTexCoord4fEXT,d0_fp0_fp3
                CALL    glMultiTexCoord4fvEXT,d0_a0
                CALL    glMultiTexCoord4iEXT,d0_d4
                CALL    glMultiTexCoord4ivEXT,d0_a0
                CALL    glMultiTexCoord4sEXT,d0_wd1_wd4
                CALL    glMultiTexCoord4svEXT,d0_a0
                CALL    glInterleavedTextureCoordSetsEXT,d0
                CALL    glSelectTextureEXT,d0
                CALL    glSelectTextureCoordSetEXT,d0
                CALL    glSelectTextureTransformEXT,d0
                CALL    glPointParameterfEXT,d0_fp0
                CALL    glPointParameterfvEXT,d0_a0
                CALL    glWindowPos2iMESA,d0_d1
                CALL    glWindowPos2sMESA,wd0_wd1
                CALL    glWindowPos2fMESA,fp0_fp1
                CALL    glWindowPos2dMESA,dfp0_dfp1
                CALL    glWindowPos2ivMESA,a0
                CALL    glWindowPos2svMESA,a0
                CALL    glWindowPos2fvMESA,a0
                CALL    glWindowPos2dvMESA,a0
                CALL    glWindowPos3iMESA,d0_d2
                CALL    glWindowPos3sMESA,wd0_wd2
                CALL    glWindowPos3fMESA,fp0_fp2
                CALL    glWindowPos3dMESA,dfp0_dfp2
                CALL    glWindowPos3ivMESA,a0
                CALL    glWindowPos3svMESA,a0
                CALL    glWindowPos3fvMESA,a0
                CALL    glWindowPos3dvMESA,a0
                CALL    glWindowPos4iMESA,d0_d3
                CALL    glWindowPos4sMESA,wd0_wd3
                CALL    glWindowPos4fMESA,fp0_fp3
                CALL    glWindowPos4dMESA,dfp0_dfp3
                CALL    glWindowPos4ivMESA,a0
                CALL    glWindowPos4svMESA,a0
                CALL    glWindowPos4fvMESA,a0
                CALL    glWindowPos4dvMESA,a0
                CALL    glResizeBuffersMESA,void
                CALL    glDrawRangeElements,d0_d4_a0
                CALL    glTexImage3D,d0_d7_a0_a1
                CALL    glTexSubImage3D,d0_d7_a0_a2
                CALL    glCopyTexSubImage3D,d0_d7_a0


_Func_void
                CALLFUNCQ

_Func_tags_a0
                INIT
                GETTAGS         a0
                CALLFUNC
                EXIT

_Func_a0_tags_a1
                INIT
                GETLONG         a0
                GETTAGS         a1
                CALLFUNC
                EXIT

_Func_d0
                INIT
                GETLONG         d0
                CALLFUNC
                EXIT

_Func_wd0
                INIT
                GETWORD         d0
                CALLFUNC
                EXIT

_Func_bd0
                INIT
                GETBYTE         d0
                CALLFUNC
                EXIT

_Func_a0
                INIT
                GETLONG         a0
                CALLFUNC
                EXIT


_Func_d0_d1
                INIT
                GETLONG         d0
                GETLONG         d1
                CALLFUNC
                EXIT

_Func_wd0_wd1
                INIT
                GETWORD         d0
                GETWORD         d1
                CALLFUNC
                EXIT

_Func_d0_a0
                INIT
                GETLONG         d0
                GETLONG         a0
                CALLFUNC
                EXIT

_Func_a0_a1
                INIT
                GETLONG         a0
                GETLONG         a1
                CALLFUNC
                EXIT

_Func_d0_d1_a0
                INIT
                GETM_LONG       d0/d1/a0
                CALLFUNC
                EXIT

_Func_d0_a0_a1
                INIT
                GETM_LONG       d0/a0/a1
                CALLFUNC
                EXIT

_Func_d0_d2_a0
                INIT
                PUSH            d2
                GETM_LONG       d0-d2/a0
                CALLFUNC
                POP             d2
                EXIT

_Func_d0_wd1
                INIT
                GETLONG         d0
                GETWORD         d1
                CALLFUNC
                EXIT

_Func_d0_d2
                INIT
                PUSH            d2
                GETM_LONG       d0-d2
                CALLFUNC
                POP             d2
                EXIT

_Func_wd0_wd2
                INIT
                PUSH            d2
                ;GETM_WORD       d0-d2
                GETWORD         d0
                GETWORD         d1
                GETWORD         d2
                CALLFUNC
                POP             d2
                EXIT

_Func_bd0_bd2
                INIT
                PUSH            d2
                GETBYTE         d0
                GETBYTE         d1
                GETBYTE         d2
                CALLFUNC
                POP             d2
                EXIT

_Func_d0_wd1_wd2
                INIT
                PUSH            d2
                GETLONG         d0
                GETWORD         d1
                GETWORD         d2
                CALLFUNC
                POP             d2
                EXIT

_Func_d0_d3
                INIT
                PUSH            d2/d3
                GETM_LONG       d0-d3
                CALLFUNC
                POP             d2/d3
                EXIT

_Func_wd0_wd3
                INIT
                PUSH            d2/d3
                ;GETM_WORD       d0-d3
                GETWORD d0
                GETWORD d1
                GETWORD d2
                GETWORD d3
                CALLFUNC
                POP             d2/d3
                EXIT

_Func_bd0_bd3
                INIT
                PUSH            d2/d3
                GETBYTE         d0
                GETBYTE         d1
                GETBYTE         d2
                GETBYTE         d3
                CALLFUNC
                POP             d2/d3
                EXIT

_Func_d0_wd1_wd3
                INIT
                PUSH            d2/d3
                GETLONG         d0
                ;GETM_WORD       d1-d3
                GETWORD d1
                GETWORD d2
                GETWORD d3
                CALLFUNC
                POP             d2/d3
                EXIT

_Func_d0_d3_a0
                INIT
                PUSH            d2/d3
                GETM_LONG       d0-d3/a0
                CALLFUNC
                POP             d2/d3
                EXIT

_Func_d0_d4
                INIT
                PUSH            d2-d4
                GETM_LONG       d0-d4
                CALLFUNC
                POP             d2-d4
                EXIT

_Func_d0_d4_a0
                INIT
                PUSH            d2-d4
                GETM_LONG       d0-d4/a0
                CALLFUNC
                POP             d2-d4
                EXIT

_Func_d0_wd1_wd4
                INIT
                PUSH            d2-d4
                GETLONG         d0
                ;GETM_WORD       d1-d4
                GETWORD d1
                GETWORD d2
                GETWORD d3
                GETWORD d4
                CALLFUNC
                POP             d2-d4
                EXIT

_Func_d0_d5
                INIT
                PUSH            d2-d5
                GETM_LONG       d0-d5
                CALLFUNC
                POP             d2-d5
                EXIT

_Func_d0_d6
                INIT
                PUSH            d2-d6
                GETM_LONG       d0-d6
                CALLFUNC
                POP             d2-d6
                EXIT

_Func_d0_d5_a0
                INIT
                PUSH            d2-d5
                GETM_LONG       d0-d5/a0
                CALLFUNC
                POP             d2-d5
                EXIT

_Func_d0_d6_a0
                INIT
                PUSH            d2-d6
                GETM_LONG       d0-d6/a0
                CALLFUNC
                POP             d2-d6
                EXIT

_Func_d0_d7
                INIT
                PUSH            d2-d7
                GETM_LONG       d0-d7
                CALLFUNC
                POP             d2-d7
                EXIT

_Func_d0_d7_a0
                INIT
                PUSH            d2-d7
                GETM_LONG       d0-d7/a0
                CALLFUNC
                POP             d2-d7
                EXIT

_Func_d0_d7_a0_a1
                INIT
                PUSH            d2-d7
                GETM_LONG       d0-d7/a0/a1
                CALLFUNC
                POP             d2-d7
                EXIT

_Func_d0_d7_a0_a2
                INIT
                PUSH            d2-d7/a2
                GETM_LONG       d0-d7/a0-a2
                CALLFUNC
                POP             d2-d7/a2
                EXIT

_Func_d0_dfp0
                INIT
                GETLONG         d0
                GETDOUBLE       fp0
                CALLFUNC
                EXIT

_Func_d0_fp0
                INIT
                GETLONG         d0
                GETFLOAT        fp0
                CALLFUNC
                EXIT

_Func_d0_d1_fp0
                INIT
                GETLONG         d0
                GETLONG         d1
                GETFLOAT        fp0
                CALLFUNC
                EXIT

_Func_d0_d1_dfp0
                INIT
                GETLONG         d0
                GETLONG         d1
                GETDOUBLE       fp0
                CALLFUNC
                EXIT

_Func_d0_fp0_fp1
                INIT
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                CALLFUNC
                EXIT

_Func_d0_dfp0_dfp1
                INIT
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                CALLFUNC
                EXIT

_Func_fp0
                INIT
                GETFLOAT        fp0
                CALLFUNC
                EXIT

_Func_dfp0
                INIT
                GETDOUBLE       fp0
                CALLFUNC
                EXIT

_Func_fp0_fp1
                INIT
                GETFLOAT        fp0
                GETFLOAT        fp1
                CALLFUNC
                EXIT

_Func_dfp0_dfp1
                INIT
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                CALLFUNC
                EXIT

_Func_d0_fp0_fp2
                INIT
                PUSHF           fp2
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                CALLFUNC
                POPF            fp2
                EXIT

_Func_d0_dfp0_dfp2
                INIT
                PUSHF           fp2
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                CALLFUNC
                POPF            fp2
                EXIT

_Func_fp0_fp2
                INIT
                PUSHF           fp2
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                CALLFUNC
                POPF            fp2
                EXIT

_Func_dfp0_dfp2
                INIT
                PUSHF           fp2
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                CALLFUNC
                POPF            fp2
                EXIT

_Func_fp0_fp3
                INIT
                PUSHF           fp2/fp3
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                GETFLOAT        fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_dfp0_dfp3
                INIT
                PUSHF           fp2/fp3
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_d0_fp0_fp3
                INIT
                PUSHF           fp2/fp3
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                GETFLOAT        fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_d0_dfp0_dfp3
                INIT
                PUSHF           fp2/fp3
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_dfp0_dfp5
                INIT
                PUSHF           fp2-fp5
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETDOUBLE       fp4
                GETDOUBLE       fp5
                CALLFUNC
                POPF            fp2-fp5
                EXIT

_Func_d0_d1_fp0_fp3_a0
                INIT
                PUSHF           fp2/fp3
                GETLONG         d0
                GETLONG         d1
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETFLOAT        fp2
                GETFLOAT        fp3
                GETLONG         a0
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_d0_dfp0_dfp1_d1_d2_a0
                INIT
                PUSH            d2
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETLONG         d1
                GETLONG         d2
                GETLONG         a0
                CALLFUNC
                POP             d2
                EXIT

_Func_d0_fp0_fp1_d1_d2_a0
                INIT
                PUSH            d2
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETLONG         d1
                GETLONG         d2
                GETLONG         a0
                CALLFUNC        glMap1f
                POP             d2
                EXIT

_Func_d0_dfp0_dfp1_d1_d2_dfp2_dfp3_d3_d4_a0
                INIT
                PUSH            d2-d4
                PUSHF           fp2/fp3
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETLONG         d1
                GETLONG         d2
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETLONG         d3
                GETLONG         d4
                GETLONG         a0
                CALLFUNC
                POPF            fp2/fp3
                POP             d2-d4
                EXIT
_Func_d0_fp0_fp1_d1_d2_fp2_fp3_d3_d4_a0
                INIT
                PUSH            d2-d4
                PUSHF           fp2/fp3
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETLONG         d1
                GETLONG         d2
                GETFLOAT        fp2
                GETFLOAT        fp3
                GETLONG         d3
                GETLONG         d4
                GETLONG         a0
                CALLFUNC
                POPF            fp2/fp3
                POP             d2-d4
                EXIT

_Func_d0_dfp0_dfp1_d1_dfp2_dfp3
                INIT
                PUSHF           fp2/fp3
                GETLONG         d0
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETLONG         d1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT

_Func_d0_fp0_fp1_d1_fp2_fp3
                INIT
                PUSHF           fp2/fp3
                GETLONG         d0
                GETFLOAT        fp0
                GETFLOAT        fp1
                GETLONG         d1
                GETFLOAT        fp2
                GETFLOAT        fp3
                CALLFUNC
                POPF            fp2/fp3
                EXIT


