#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <proto/exec.h>
#include "glsm.h"
#include "glusm.h"
#include "glutsm.h"

struct Library* glBase = NULL;
struct Library* gluBase = NULL;
struct Library* glutBase = NULL;

struct glreg gl_reg;
struct glureg glu_reg;
struct glutreg glut_reg;

ULONG oldfpu;

ULONG SetFPU(void);
void RestoreFPU(ULONG);

void INIT_8_OpenLibs(void) __attribute__ ((constructor));
void EXIT_8_OpenLibs(void) __attribute__ ((destructor));

void INIT_8_OpenLibs(void)
{
		oldfpu = SetFPU();
		if (!(glBase = OpenLibrary("agl.library",0)))
		{
				printf("Failed to open 'agl.library'\n");
				exit(0);
		}
		if (!(gluBase = OpenLibrary("aglu.library",0)))
		{
				printf("Failed to open 'aglu.library'\n");
				exit(0);
		}
		if (!(glutBase = OpenLibrary("aglut.library",0)))
		{
				printf("Failed to open 'aglut.library'\n");
				exit(0);
		}
		CacheClearU();
		gl_reg.size = (int)sizeof(struct glreg);
		gl_reg.func_exit = exit;
		registerGL(&gl_reg);
		glu_reg.size = (int)sizeof(struct glureg);
		glu_reg.glbase = glBase;
		registerGLU(&glu_reg);
		glut_reg.size = (int)sizeof(struct glutreg);
		glut_reg.func_exit = exit;
		glut_reg.glbase = glBase;
		glut_reg.glubase = gluBase;
		glut_reg.base = NULL;
		glut_reg.charmode = 1;
		registerGLUT(&glut_reg);
}

void EXIT_8_OpenLibs(void)
{
		if (glutBase)
				CloseLibrary(glutBase);
		if (gluBase)
				CloseLibrary(gluBase);
		if (glBase)
				CloseLibrary(glBase);
		RestoreFPU(oldfpu);
}
