#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <powerup/ppcproto/exec.h>
#include "glsm.h"
#include "glusm.h"
#include "glutsm.h"


struct Library* glppcBase = NULL;
struct Library* gluppcBase = NULL;
struct Library* glutppcBase = NULL;

struct glreg gl_reg;
struct glureg glu_reg;
struct glutreg glut_reg;

asm("		
		.globl getR2
getR2:		mr	3,2
		blr
		");

asm("		.globl registerGL
registerGL:	stwu	1,-32(1)
		stw	2,28(1)
		mflr	2
		stw	2,24(1)
		lis	2,glppcBase@ha
		lwz	2,glppcBase@l(2)
		lwz	4,-30+2(2)
		mtlr	4
		blrl
		lwz	2,24(1)
		mtlr	2
		lwz	2,28(1)
		la	1,32(1)
		blr
		");

asm("		.globl registerGLU
registerGLU:	stwu	1,-32(1)
		stw	2,28(1)
		mflr	2
		stw	2,24(1)
		lis	2,gluppcBase@ha
		lwz	2,gluppcBase@l(2)
		lwz	4,-30+2(2)
		mtlr	4
		blrl
		lwz	2,24(1)
		mtlr	2
		lwz	2,28(1)
		la	1,32(1)
		blr
		");

asm("		.globl registerGLUT
registerGLUT:	stwu	1,-32(1)
		stw	2,28(1)
		mflr	2
		stw	2,24(1)
		lis	2,glutppcBase@ha
		lwz	2,glutppcBase@l(2)
		lwz	4,-30+2(2)
		mtlr	4
		blrl
		lwz	2,24(1)
		mtlr	2
		lwz	2,28(1)
		la	1,32(1)
		blr
		");

void	*getR2();

//void INIT_8_OpenLibs(void) __attribute__ ((constructor));
//void EXIT_8_OpenLibs(void) __attribute__ ((destructor));

asm("		.section	.ctors,\"aw\"
		.long		INIT_8_OpenLibs
		.section	.dtors,\"aw\"
		.long		EXIT_8_OpenLibs");

void INIT_8_OpenLibs(void)
{
	if (!(glppcBase = OpenLibrary("aglppc.library",0)))
	{
		printf("Failed to open 'aglppc.library'\n");
		exit(0);
	}
	if (!(gluppcBase = OpenLibrary("agluppc.library",0)))
	{
		printf("Failed to open 'agluppc.library'\n");
		exit(0);
	}
	if (!(glutppcBase = OpenLibrary("aglutppc.library",0)))
	{
		printf("Failed to open 'aglutppc.library'\n");
		exit(0);
	}
	gl_reg.size = (int)sizeof(struct glreg);
	gl_reg.func_exit = exit;
	gl_reg.base = (void *)getR2();
	registerGL(&gl_reg);
	glu_reg.size = (int)sizeof(struct glureg);
	glu_reg.glbase = glppcBase;
	glu_reg.base = (void *)getR2();
	registerGLU(&glu_reg);
	glut_reg.size = (int)sizeof(struct glutreg);
	glut_reg.func_exit = exit;
	glut_reg.glbase = glppcBase;
	glut_reg.glubase = gluppcBase;
	glut_reg.base = (void *)getR2();
	registerGLUT(&glut_reg);
}

void EXIT_8_OpenLibs(void)
{
	if (glutppcBase)
		CloseLibrary(glutppcBase);
	if (gluppcBase)
		CloseLibrary(gluppcBase);
	if (glppcBase)
		CloseLibrary(glppcBase);
}
