* IMPORTANT: this file probably needs to be modified for use with
* other compilers then StormC (for example check out byte parameter
* transfer). Also change the macros CALLF,XDEFF to your needs (Storm
* adds a suffix for functions which return floats and doubles)

                include gle_lib.i
                fpu
                far

INIT            macro
                movem.l a4-a6,-(sp)
                lea     16(sp),a5
                move.l  _gleBase,a6
                add.l   a6,a0
                move.l  a0,a4
                endm

EXIT            macro
                movem.l (sp)+,a4-a6
                rts
                endm

CALLFUNC        macro
                jsr     0(a4)
                endm

CALLFUNCQ       macro
                move.l  a6,-(sp)
                move.l  _gleBase,a6
                jsr     0(a6,a0.l)
                move.l  (sp)+,a6
                rts
                endm

GETM_LONG       macro
                movem.l (a5)+,\1
                endm

GETM_WORD       macro
                movem.w (a5)+,\1
                endm

GETFLOAT        macro
                fmove.s (a5)+,\1
                endm

GETDOUBLE       macro
                fmove.d (a5)+,\1
                endm

GETLONG         macro
                move.l  (a5)+,\1
                endm

GETWORD         macro
                move.w  (a5)+,\1
                endm

GETBYTE         macro           ; might not work with other compilers!
                move.b  (a5)+,\1
                addq.l  #1,a5
                endm

GETTAGS         macro
                move.l  a5,\1
                endm

PUSH            macro
                movem.l \1,-(sp)
                endm

PUSHF           macro
                fmovem.x        \1,-(sp)
                endm

POP             macro
                movem.l (sp)+,\1
                endm

POPF            macro
                fmovem.x        (sp)+,\1
                endm

CALL            macro
_\1
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

CALLF           macro
_\1__r
                move    #_LVO\1,a0
                bra     _Func_\2
                endm

CALLD           macro
_\1
                move.l  a6,-(sp)
                move.l  _gleBase,a6
                jsr     _LVO\1(a6)
                move.l  (sp)+,a6
                rts
                endm

XDEFF           macro
                XDEF    \1__r
                endm

                XREF    _gleBase

                XDEF    _registerGLE
                XDEF    _gleGetJoinStyle
                XDEF    _gleSetJoinStyle
                XDEF    _gleGetNumSlices
                XDEF    _gleSetNumSlices
                XDEF    _glePolyCylinder
                XDEF    _glePolyCone
                XDEF    _gleExtrusion
                XDEF    _gleTwistExtrusion
                XDEF    _gleSuperExtrusion
                XDEF    _gleSpiral
                XDEF    _gleLathe
                XDEF    _gleHelicoid
                XDEF    _gleToroid
                XDEF    _gleScrew
                XDEF    _gleTextureMode

                section "gleStubs",code

                CALLD   registerGLE
                CALL    gleGetJoinStyle,void
                CALL    gleSetJoinStyle,d0
                CALL    gleGetNumSlices,void
                CALL    gleSetNumSlices,d0
                CALL    glePolyCylinder,d0_a0_a1_dfp0
                CALL    glePolyCone,d0_a0_a2
                CALL    gleExtrusion,d0_a0_a2_d1_a3_d2
                CALL    gleTwistExtrusion,d0_a0_a2_d1_a3_d2_d3
                CALL    gleSuperExtrusion,d0_a0_a2_d1_a3_d2_d3
                CALL    gleSpiral,d0_a0_a2_dfp0_dfp3_a3_d1_dfp4_dfp5
                CALL    gleLathe,d0_a0_a2_dfp0_dfp3_a3_d1_dfp4_dfp5
                CALL    gleHelicoid,dfp0_dfp4_a0_a1_dfp5_dfp6
                CALL    gleToroid,dfp0_dfp4_a0_a1_dfp5_dfp6
                CALL    gleScrew,d0_a0_a2_dfp0_dfp2
                CALL    gleTextureMode,d0

_Func_void
                CALLFUNCQ

_Func_d0
                INIT
                GETLONG         d0
                CALLFUNC
                EXIT

_Func_d0_a0_a2
                INIT
                PUSH            a2
                GETLONG         d0
                GETM_LONG       a0-a2
                CALLFUNC
                POP             a2
                EXIT

_Func_d0_a0_a1_dfp0
                INIT
                GETLONG         d0
                GETLONG         a0
                GETLONG         a1
                GETDOUBLE       fp0
                CALLFUNC
                EXIT

_Func_d0_a0_a2_d1_a3_d2
                INIT
                PUSH            d2/a2/a3
                GETLONG         d0
                GETM_LONG       a0-a2
                GETLONG         d1
                GETLONG         a3
                GETLONG         d2
                CALLFUNC
                POP             d2/a2/a3
                EXIT

_Func_d0_a0_a2_d1_a3_d2_d3
                INIT
                PUSH            d2/d3/a2/a3
                GETLONG         d0
                GETM_LONG       a0-a2
                GETLONG         d1
                GETLONG         a3
                GETLONG         d2
                GETLONG         d3
                CALLFUNC
                POP             d2/d3/a2/a3
                EXIT

_Func_d0_a0_a2_dfp0_dfp2
                INIT
                PUSH            a2
                PUSHF           fp2
                GETLONG         d0
                GETM_LONG       a0-a2
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                CALLFUNC
                POPF            fp2
                POP             a2
                EXIT

_Func_dfp0_dfp4_a0_a1_dfp5_dfp6
                INIT
                PUSHF           fp2-fp6
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETDOUBLE       fp4
                GETLONG         a0
                GETLONG         a1
                GETDOUBLE       fp5
                GETDOUBLE       fp6
                CALLFUNC
                POPF            fp2-fp6
                EXIT

_Func_d0_a0_a2_dfp0_dfp3_a3_d1_dfp4_dfp5
                INIT
                PUSH            a2/a3
                PUSHF           fp2-fp5
                GETLONG         d0
                GETM_LONG       a0-a2
                GETDOUBLE       fp0
                GETDOUBLE       fp1
                GETDOUBLE       fp2
                GETDOUBLE       fp3
                GETLONG         a3
                GETLONG         d1
                GETDOUBLE       fp4
                GETDOUBLE       fp5
                CALLFUNC
                POPF            fp2-fp5
                POP             a2/a3
                EXIT
