#include <stdio.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <clib/exec_protos.h>
#include "glsm.h"
#include "glusm.h"
#include "glutsm.h"

void* getR2();

struct Library* glppcBase = NULL;
struct Library* gluppcBase = NULL;
struct Library* glutppcBase = NULL;

struct glreg gl_reg;
struct glureg glu_reg;
struct glutreg glut_reg;

INIT_8_OpenLibs(void)
{
	if (!(glppcBase = OpenLibrary("aglppc.library",0)))
	{
		printf("Failed to open 'aglppc.library'\n");
		exit(0);
	}
	if (!(gluppcBase = OpenLibrary("agluppc.library",0)))
	{
		printf("Failed to open 'agluppc.library'\n");
		exit(0);
	}
	if (!(glutppcBase = OpenLibrary("aglutppc.library",0)))
	{
		printf("Failed to open 'aglutppc.library'\n");
		exit(0);
	}
	gl_reg.size = (int)sizeof(struct glreg);
	gl_reg.func_exit = exit;
	gl_reg.base = (void *)getR2();
	registerGL(&gl_reg);
	glu_reg.size = (int)sizeof(struct glureg);
	glu_reg.glbase = glppcBase;
	glu_reg.base = (void *)getR2();
	registerGLU(&glu_reg);
	glut_reg.size = (int)sizeof(struct glutreg);
	glut_reg.func_exit = exit;
	glut_reg.glbase = glppcBase;
	glut_reg.glubase = gluppcBase;
	glut_reg.base = (void *)getR2();
	registerGLUT(&glut_reg);
}

EXIT_8_OpenLibs(void)
{
	if (glutppcBase)
		CloseLibrary(glutppcBase);
	if (gluppcBase)
		CloseLibrary(gluppcBase);
	if (glppcBase)
		CloseLibrary(glppcBase);
}
