#include <stdio.h>
#include <stdlib.h>
#include <exec/types.h>
#include <exec/libraries.h>
#include <exec/execbase.h>
#include <proto/exec.h>
#include "glinit.h"


extern struct ExecBase *SysBase;
struct Library *GLBASE = NULL;
struct Library *GLUBASE = NULL;
struct Library *GLUTBASE = NULL;
#ifndef __PPC__
static ULONG oldfpu = 0xffffffff;
#endif



void _INIT_8_gl()
{
  static char *failed_txt = "Failed to open '%s'\n";
  static char *agl_name = GLNAME;
  static char *aglu_name = GLUNAME;
  static char *aglut_name = GLUTNAME;

#ifndef __PPC__
  if (SysBase->LibNode.lib_Version < 36 ||
      (SysBase->AttnFlags&(AFF_68020|AFF_68881)) != (AFF_68020|AFF_68881)) {
    fprintf(stderr,"Init failed! Minimum requirements: OS2.0, 68020, 68881.\n");
    exit(EXIT_FAILURE);
  }
  oldfpu = _gl_init_SetFPU();
#endif
  if (!(GLBASE = OpenLibrary(agl_name,0))) {
    fprintf(stderr,failed_txt,agl_name);
    exit(EXIT_FAILURE);
  }
  if (!(GLUBASE = OpenLibrary(aglu_name,0))) {
    fprintf(stderr,failed_txt,aglu_name);
    exit(EXIT_FAILURE);
  }
  if (!(GLUTBASE = OpenLibrary(aglut_name,0))) {
    fprintf(stderr,failed_txt,aglut_name);
    exit(EXIT_FAILURE);
  }
#ifndef __PPC__
  CacheClearU();
#endif
  gl_reg.size = (int)sizeof(struct glreg);
  gl_reg.func_exit = exit;
#ifdef __PPC__
  gl_reg.base = getR2();
#endif
  registerGL(&gl_reg);
  glu_reg.size = (int)sizeof(struct glureg);
  glu_reg.glbase = GLBASE;
#ifdef __PPC__
  glu_reg.base = getR2();
#endif
  registerGLU(&glu_reg);
  glut_reg.size = (int)sizeof(struct glutreg);
  glut_reg.func_exit = exit;
  glut_reg.glbase = GLBASE;
  glut_reg.glubase = GLUBASE;
#ifdef __PPC__
  glut_reg.base = getR2();
#else
  glut_reg.base = (void *)0;
#endif
  glut_reg.charmode = 1;
  registerGLUT(&glut_reg);
}


void _EXIT_8_gl()
{
  if (GLUTBASE)
    CloseLibrary(GLUTBASE);
  if (GLUBASE)
    CloseLibrary(GLUBASE);
  if (GLBASE)
    CloseLibrary(GLBASE);
#ifndef __PPC__
  if (oldfpu != 0xffffffff)
    _gl_init_RestoreFPU(oldfpu);
#endif
}
