/*
** glinit.h for Amiga/M68k and WarpOS/PPC
*/

#ifndef __PPC__
#define GLBASE glBase
#define GLUBASE gluBase
#define GLUTBASE glutBase
#define GLNAME "agl.library"
#define GLUNAME "aglu.library"
#define GLUTNAME "aglut.library"

#else
#define GLBASE glppcBase
#define GLUBASE gluppcBase
#define GLUTBASE glutppcBase
#define GLNAME "aglppc.library"
#define GLUNAME "agluppc.library"
#define GLUTNAME "aglutppc.library"

extern void *getR2();
#endif

static struct glreg
{
  int size;
  void (*func_exit)();
#ifdef __PPC__
  void *base;
#endif
} gl_reg;

static struct glureg
{
  int size;
  struct Library *glbase;
#ifdef __PPC__
  void *base;
#endif
} glu_reg;

static struct glutreg
{
  int size;
  void (*func_exit)();
  struct Library *glbase;
  struct Library *glubase;
#ifdef __PPC__
  void *base;
#endif
  int charmode;
} glut_reg;


#ifndef __PPC__
void __registerGL(__reg("a0")struct glreg *,__reg("a6") void *) =
        "\tjsr\t-30(a6)";
void __registerGLU(__reg("a0")struct glureg *,__reg("a6") void *) =
        "\tjsr\t-30(a6)";
void __registerGLUT(__reg("a0")struct glutreg *,__reg("a6") void *) =
        "\tjsr\t-30(a6)";

#define registerGL(x) __registerGL(x,glBase)
#define registerGLU(x) __registerGLU(x,gluBase)
#define registerGLUT(x) __registerGLUT(x,glutBase)

#else
void __registerGL(struct glreg *) =
        "\tstw\tr2,20(r1)\n"
        "\tlwz\tr2,_glppcBase(r2)\n"
        "\tlwz\tr0,-28(r2)\n"
        "\tmtlr\tr0\n"
        "\tblrl\n"
        "\tlwz\tr2,20(r1)";
void __registerGLU(struct glureg *) =
        "\tstw\tr2,20(r1)\n"
        "\tlwz\tr2,_gluppcBase(r2)\n"
        "\tlwz\tr0,-28(r2)\n"
        "\tmtlr\tr0\n"
        "\tblrl\n"
        "\tlwz\tr2,20(r1)";
void __registerGLUT(struct glutreg *) =
        "\tstw\tr2,20(r1)\n"
        "\tlwz\tr2,_glutppcBase(r2)\n"
        "\tlwz\tr0,-28(r2)\n"
        "\tmtlr\tr0\n"
        "\tblrl\n"
        "\tlwz\tr2,20(r1)";

#define registerGL(x) __registerGL(x)
#define registerGLU(x) __registerGLU(x)
#define registerGLUT(x) __registerGLUT(x)
#endif


#ifndef __PPC__
ULONG _gl_init_SetFPU(void) =
        "\tfmove.l\tfpcr,d0\n"
        "\tmoveq\t#-$31,d1\n"
        "\tand.l\td0,d1\n"
        "\tor.b\t#$10,d1\n"
        "\tfmove.l\td1,fpcr";

void _gl_init_RestoreFPU(__reg("d0")ULONG) =
        "\tfmove.l\td0,fpcr";
#endif
