
                include graphics/gfx.i

                XDEF    _ChunkyToPlanar


                mc68020

merge           macro
                move.l  \2,\4
                move.l  #\5,\3
                and.l   \3,\2
                and.l   \1,\3
                eor.l   \3,\1
                eor.l   \2,\4
                ifeq    \6-1
                add.l   \3,\3
                else
                lsl.l   #\6,\3
                endc
                lsr.l   #\6,\4
                or.l    \3,\2
                or.l    \4,\1
                endm


******************************************************************************
*
*       void ChunkyToPlanar(unsigned char* src,struct BitMap *dest,
*                           int width,int height);
*
*       converts chunky data into bitplane data (using Bitmap Structure)
*       works only with depth = 8 (but any width/height)
*       the bitplanes don't have to be allocated in one piece
*       the bitplanes must not be interleaved
*
*       original algorithm by James McCoull (I found the source somewhere
*       on the AMINET CD's)
*
******************************************************************************
_ChunkyToPlanar
                movem.l d0-a6,-(sp)
                move.l  64(sp),a0
                move.l  64+4(sp),a1
                move.l  64+8(sp),d0
                move.l  64+12(sp),d1
                mulu    d0,d1
                move.l  a0,a4
                add.l   d1,a4
                sub.w   #40+28,sp       ; space for temporary variables
                lea     40(sp),a3       ; space for bitmap distances

                lea     bm_Planes(a1),a1
                moveq   #7-1,d2
.create
                move.l  (a1)+,d0
                move.l  (a1),d1
                sub.l   d0,d1
                move.l  d1,(a3)+
                dbra    d2,.create
                lea     -28(a3),a3
                move.l  -28(a1),a1

first_case
                move.l  (0,a0),d1
                move.l  (4,a0),d3
                move.l  (8,a0),d0
                move.l  (12,a0),d2
                move.l  (2,a0),d4
                move.l  (10,a0),d5
                move.l  (6,a0),d6
                move.l  (14,a0),d7

                move.w  (16,a0),d1
                move.w  (24,a0),d0
                move.w  (20,a0),d3
                move.w  (28,a0),d2
                move.w  (18,a0),d4
                move.w  (26,a0),d5
                move.w  (22,a0),d6
                move.w  (30,a0),d7

                adda.w  #32,a0

                move.l  d6,a5
                move.l  d7,a6

                merge   d1,d0,d6,d7,$00ff00ff,8
                merge   d3,d2,d6,d7,$00ff00ff,8

                merge   d1,d3,d6,d7,$0f0f0f0f,4
                merge   d0,d2,d6,d7,$0f0f0f0f,4

                exg     d1,a5
                exg     d0,a6

                merge   d4,d5,d6,d7,$00ff00ff,8
                merge   d1,d0,d6,d7,$00ff00ff,8

                merge   d4,d1,d6,d7,$0f0f0f0f,4
                merge   d5,d0,d6,d7,$0f0f0f0f,4

                merge   d3,d1,d6,d7,$33333333,2
                merge   d2,d0,d6,d7,$33333333,2

                merge   d3,d2,d6,d7,$55555555,1
                merge   d1,d0,d6,d7,$55555555,1

                move.l  d0,(0*4,sp)             ;plane0
                move.l  d1,(1*4,sp)             ;plane1
                move.l  d2,(2*4,sp)             ;plane2
                move.l  d3,(3*4,sp)             ;plane3

                move.l  a5,d3
                move.l  a6,d2

                merge   d3,d4,d6,d7,$33333333,2
                merge   d2,d5,d6,d7,$33333333,2

                merge   d3,d2,d6,d7,$55555555,1
                merge   d4,d5,d6,d7,$55555555,1

                move.l  d5,(4*4,sp)             ;plane4
                move.l  d4,(5*4,sp)             ;plane5

                move.l  d2,(6*4,sp)             ;plane6
                move.l  d3,(7*4,sp)             ;plane7

                move.l  a1,(32,sp)              ; save output address
                addq.l  #4,a1                   ; skip 32 pixels on output

                cmpa.l  a0,a4
                beq.w   final_case



main_case
                move.l  a1,(36,sp)      ; save current output address
                move.l  (32,sp),a1      ; a1 = previous output address

                move.l  (0,a0),d1
                move.l  (4,a0),d3
                move.l  (8,a0),d0
                move.l  (12,a0),d2
                move.l  (2,a0),d4
                move.l  (10,a0),d5
                move.l  (6,a0),d6
                move.l  (14,a0),d7

                move.w  (16,a0),d1
                move.w  (24,a0),d0
                move.w  (20,a0),d3
                move.w  (28,a0),d2
                move.w  (18,a0),d4
                move.w  (26,a0),d5
                move.w  (22,a0),d6
                move.w  (30,a0),d7

                adda.w  #32,a0

                move.l  d6,a5
                move.l  d7,a6

                move.l  (0*4,sp),(a1)           ;plane0
                adda.l  (a3)+,a1

                merge   d1,d0,d6,d7,$00ff00ff,8
                merge   d3,d2,d6,d7,$00ff00ff,8

                move.l  (1*4,sp),(a1)           ;plane1
                adda.l  (a3)+,a1

                merge   d1,d3,d6,d7,$0f0f0f0f,4
                merge   d0,d2,d6,d7,$0f0f0f0f,4

                exg     d1,a5
                exg     d0,a6

                move.l  (2*4,sp),(a1)           ;plane2
                adda.l  (a3)+,a1

                merge   d4,d5,d6,d7,$00ff00ff,8
                merge   d1,d0,d6,d7,$00ff00ff,8

                move.l  (3*4,sp),(a1)           ;plane3
                adda.l  (a3)+,a1

                merge   d4,d1,d6,d7,$0f0f0f0f,4
                merge   d5,d0,d6,d7,$0f0f0f0f,4

                move.l  (4*4,sp),(a1)           ;plane4
                adda.l  (a3)+,a1

                merge   d3,d1,d6,d7,$33333333,2
                merge   d2,d0,d6,d7,$33333333,2

                move.l  (5*4,sp),(a1)           ;plane5
                adda.l  (a3)+,a1

                merge   d3,d2,d6,d7,$55555555,1
                merge   d1,d0,d6,d7,$55555555,1

                move.l  d0,(0*4,sp)             ;plane0 (movem.l is slower!)
                move.l  d1,(1*4,sp)             ;plane1
                move.l  d2,(2*4,sp)             ;plane2
                move.l  d3,(3*4,sp)             ;plane3

                move.l  a5,d3
                move.l  a6,d2

                move.l  (6*4,sp),(a1)           ;plane6
                adda.l  (a3)+,a1

                merge   d3,d4,d6,d7,$33333333,2
                merge   d2,d5,d6,d7,$33333333,2

                move.l  (7*4,sp),(a1)           ;plane7

                merge   d3,d2,d6,d7,$55555555,1
                merge   d4,d5,d6,d7,$55555555,1

                move.l  d5,(4*4,sp)             ;plane4
                move.l  d4,(5*4,sp)             ;plane5

                move.l  d2,(6*4,sp)             ;plane6
                move.l  d3,(7*4,sp)             ;plane7

                lea     -28(a3),a3
                movea.l (36,sp),a1      ; restore current output address
                move.l  a1,(32,sp)      ; save output address
                addq.l  #4,a1

                cmpa.l  a0,a4
                bne.w   main_case


final_case
                move.l  (32,sp),a1      ; a1 = previous output address

                move.l  (0*4,sp),(a1)           ;plane0
                adda.l  (a3)+,a1
                move.l  (1*4,sp),(a1)           ;plane1
                adda.l  (a3)+,a1
                move.l  (2*4,sp),(a1)           ;plane2
                adda.l  (a3)+,a1
                move.l  (3*4,sp),(a1)           ;plane3
                adda.l  (a3)+,a1
                move.l  (4*4,sp),(a1)           ;plane4
                adda.l  (a3)+,a1
                move.l  (5*4,sp),(a1)           ;plane5
                adda.l  (a3)+,a1
                move.l  (6*4,sp),(a1)           ;plane6
                adda.l  (a3)+,a1
                move.l  (7*4,sp),(a1)           ;plane7

exit
                add.w   #40+28,sp
                movem.l (sp)+,d0-a6
                rts



