/*
 * Mesa 3-D graphics library
 * Version:  2.2
 * Copyright (C) 1995-1997  Brian Paul
 *
 * This library is free software you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <GL/gl.h>

void APIENTRY smglClearIndex(register __fp0 GLfloat c )
{
	glClearIndex(c);
}

void APIENTRY smglClearColor(register __fp0 GLclampf red,
				  register __fp1 GLclampf green,
				  register __fp2 GLclampf blue,
				  register __fp3 GLclampf alpha )
{
	glClearColor(red,green,blue,alpha);
}

void APIENTRY smglClear(register __d0 GLbitfield mask )
{
	glClear(mask);
}

void APIENTRY smglIndexMask(register __d0 GLuint mask )
{
	glIndexMask(mask);
}

void APIENTRY smglColorMask(register __d0 GLboolean red,
				 register __d1 GLboolean green,
				 register __d2 GLboolean blue,
				 register __d3 GLboolean alpha )
{
	glColorMask(red,green,blue,alpha);
}

void APIENTRY smglAlphaFunc(register __d0 GLenum func,
				 register __fp0 GLclampf ref )
{
	glAlphaFunc(func,ref);
}

void APIENTRY smglBlendFunc(register __d0 GLenum sfactor,
				 register __d1 GLenum dfactor )
{
	glBlendFunc(sfactor,dfactor);
}

void APIENTRY smglLogicOp(register __d0 GLenum opcode )
{
	glLogicOp(opcode);
}

void APIENTRY smglCullFace(register __d0 GLenum mode )
{
	glCullFace(mode);
}

void APIENTRY smglFrontFace(register __d0 GLenum mode )
{
	glFrontFace(mode);
}

void APIENTRY smglPointSize(register __fp0 GLfloat size )
{
	glPointSize(size);
}

void APIENTRY smglLineWidth(register __fp0 GLfloat width )
{
	glLineWidth(width);
}

void APIENTRY smglLineStipple(register __d0 GLint factor,
				   register __d1 GLushort pattern )
{
	glLineStipple(factor,pattern);
}

void APIENTRY smglPolygonMode(register __d0 GLenum face,
				   register __d1 GLenum mode )
{
	glPolygonMode(face,mode);
}

void APIENTRY smglPolygonOffset(register __fp0 GLfloat factor,
				     register __fp1 GLfloat units )
{
	glPolygonOffset(factor,units);
}

void APIENTRY smglPolygonStipple(register __a0 const GLubyte *mask )
{
	glPolygonStipple(mask);
}

void APIENTRY smglGetPolygonStipple(register __a0 GLubyte *mask )
{
	glGetPolygonStipple(mask);
}

void APIENTRY smglEdgeFlag(register __d0 GLboolean flag )
{
	glEdgeFlag(flag);
}

void APIENTRY smglEdgeFlagv(register __a0 const GLboolean *flag )
{
	glEdgeFlagv(flag);
}

void APIENTRY smglScissor(register __d0 GLint x,
			       register __d1 GLint y,
			       register __d2 GLsizei width,
			       register __d3 GLsizei height)
{
	glScissor(x,y,width,height);
}

void APIENTRY smglClipPlane(register __d0 GLenum plane,
				 register __a0 const GLdouble *equation )
{
	glClipPlane(plane,equation);
}

void APIENTRY smglGetClipPlane(register __d0 GLenum plane,
				    register __a0 GLdouble *equation )
{
	glGetClipPlane(plane,equation);
}

void APIENTRY smglDrawBuffer(register __d0 GLenum mode )
{
	glDrawBuffer(mode);
}

void APIENTRY smglReadBuffer(register __d0 GLenum mode )
{
	glReadBuffer(mode);
}

void APIENTRY smglEnable(register __d0 GLenum cap )
{
	glEnable(cap);
}

void APIENTRY smglDisable(register __d0 GLenum cap )
{
	glDisable(cap);
}

GLboolean APIENTRY smglIsEnabled(register __d0 GLenum cap )
{
	return (glIsEnabled(cap));
}

void APIENTRY smglEnableClientState( register __d0 GLenum cap )
{
	glEnableClientState(cap);
}

void APIENTRY smglDisableClientState( register __d0 GLenum cap )
{
	glDisableClientState(cap);
}


void APIENTRY smglGetBooleanv(register __d0 GLenum pname,
				   register __a0 GLboolean *params )
{
	glGetBooleanv(pname,params);
}

void APIENTRY smglGetDoublev(register __d0 GLenum pname,
				  register __a0 GLdouble *params )
{
	glGetDoublev(pname,params);
}

void APIENTRY smglGetFloatv(register __d0 GLenum pname,
				 register __a0 GLfloat *params )
{
	glGetFloatv(pname,params);
}

void APIENTRY smglGetIntegerv(register __d0 GLenum pname,
				   register __a0 GLint *params )
{
	glGetIntegerv(pname,params);
}


void APIENTRY smglPushAttrib(register __d0 GLbitfield mask )
{
	glPushAttrib(mask);
}

void APIENTRY smglPopAttrib(void )
{
	glPopAttrib();
}

void APIENTRY smglPushClientAttrib( register __d0 GLbitfield mask )
{
	glPushClientAttrib(mask);
}

void APIENTRY smglPopClientAttrib(void )
{
	glPopClientAttrib();
}


GLint APIENTRY smglRenderMode(register __d0 GLenum mode )
{
	return(glRenderMode(mode));
}

GLenum APIENTRY smglGetError(void )
{
	return(glGetError());
}

const GLubyte* APIENTRY smglGetString(register __d0 GLenum name )
{
	return(glGetString(name));
}

void APIENTRY smglFinish(void )
{
	glFinish();
}

void APIENTRY smglFlush(void )
{
	glFlush();
}

void APIENTRY smglHint(register __d0 GLenum target,
			    register __d1 GLenum mode )
{
	glHint(target,mode);
}



/*
 * Depth Buffer
 */

void APIENTRY smglClearDepth(register __fp0 GLclampd depth )
{
	glClearDepth(depth);
}

void APIENTRY smglDepthFunc(register __d0 GLenum func )
{
	glDepthFunc(func);
}

void APIENTRY smglDepthMask(register __d0 GLboolean flag )
{
	glDepthMask(flag);
}

void APIENTRY smglDepthRange(register __fp0 GLclampd near_val,
				  register __fp1 GLclampd far_val )
{
	glDepthRange(near_val,far_val);
}


/*
 * Accumulation Buffer
 */

void APIENTRY smglClearAccum(register __fp0 GLfloat red,
				  register __fp1 GLfloat green,
				  register __fp2 GLfloat blue,
				  register __fp3 GLfloat alpha )
{
	glClearAccum(red,green,blue,alpha);
}

void APIENTRY smglAccum(register __d0 GLenum op,
			     register __fp0 GLfloat value )
{
	glAccum(op,value);
}


/*
 * Transformation
 */

void APIENTRY smglMatrixMode(register __d0 GLenum mode )
{
	glMatrixMode(mode);
}

void APIENTRY smglOrtho(register __fp0 GLdouble left,
			     register __fp1 GLdouble right,
			     register __fp2 GLdouble bottom,
			     register __fp3 GLdouble top,
			     register __fp4 GLdouble nearval,
			     register __fp5 GLdouble farval )
{
	glOrtho(left,right,bottom,top,nearval,farval);
}

void APIENTRY smglFrustum(register __fp0 GLdouble left,
			       register __fp1 GLdouble right,
			       register __fp2 GLdouble bottom,
			       register __fp3 GLdouble top,
			       register __fp4 GLdouble nearval,
			       register __fp5 GLdouble farval )
{
	glFrustum(left,right,bottom,top,nearval,farval);
}

void APIENTRY smglViewport(register __d0 GLint x,
				register __d1 GLint y,
				register __d2 GLsizei width,
				register __d3 GLsizei height )
{
	glViewport(x,y,width,height);
}

void APIENTRY smglPushMatrix(void )
{
	glPushMatrix();
}

void APIENTRY smglPopMatrix(void )
{
	glPopMatrix();
}

void APIENTRY smglLoadIdentity(void )
{
	glLoadIdentity();
}

void APIENTRY smglLoadMatrixd(register __a0 const GLdouble *m )
{
	glLoadMatrixd(m);
}
void APIENTRY smglLoadMatrixf(register __a0 const GLfloat *m )
{
	glLoadMatrixf(m);
}

void APIENTRY smglMultMatrixd(register __a0 const GLdouble *m )
{
	glMultMatrixd(m);
}
void APIENTRY smglMultMatrixf(register __a0 const GLfloat *m )
{
	glMultMatrixf(m);
}

void APIENTRY smglRotated(register __fp0 GLdouble angle,
			       register __fp1 GLdouble x,
			       register __fp2 GLdouble y,
			       register __fp3 GLdouble z )
{
	glRotated(angle,x,y,z);
}
void APIENTRY smglRotatef(register __fp0 GLfloat angle,
			       register __fp1 GLfloat x,
			       register __fp2 GLfloat y,
			       register __fp3 GLfloat z )
{
	glRotatef(angle,x,y,z);
}

void APIENTRY smglScaled(register __fp0 GLdouble x,
			      register __fp1 GLdouble y,
			      register __fp2 GLdouble z )
{
	glScaled(x,y,z);
}
void APIENTRY smglScalef(register __fp0 GLfloat x,
			      register __fp1 GLfloat y,
			      register __fp2 GLfloat z )
{
	glScalef(x,y,z);
}

void APIENTRY smglTranslated(register __fp0 GLdouble x,
				  register __fp1 GLdouble y,
				  register __fp2 GLdouble z )
{
	glTranslated(x,y,z);
}
void APIENTRY smglTranslatef(register __fp0 GLfloat x,
				  register __fp1 GLfloat y,
				  register __fp2 GLfloat z )
{
	glTranslatef(x,y,z);
}



/*
 * Display Lists
 */

GLboolean APIENTRY smglIsList(register __d0 GLuint list )
{
	return(glIsList(list));
}

void APIENTRY smglDeleteLists(register __d0 GLuint list,
				   register __d1  GLsizei range )
{
	glDeleteLists(list,range);
}

GLuint APIENTRY smglGenLists(register __d0 GLsizei range )
{
	return(glGenLists(range));
}

void APIENTRY smglNewList(register __d0 GLuint list,
			       register __d1 GLenum mode )
{
	glNewList(list,mode);
}

void APIENTRY smglEndList(void )
{
	glEndList();
}

void APIENTRY smglCallList(register __d0 GLuint list )
{
	glCallList(list);
}

void APIENTRY smglCallLists(register __d0 GLsizei n,
				 register __d1 GLenum type,
				 register __a0 const GLvoid *lists )
{
	glCallLists(n,type,lists);
}

void APIENTRY smglListBase(register __d0 GLuint base )
{
	glListBase(base);
}



/*
 * Drawing Functions
 */

void APIENTRY smglBegin(register __d0 GLenum mode )
{
	glBegin(mode);
}

void APIENTRY smglEnd(void )
{
	glEnd();
}

void APIENTRY smglVertex2d(register __fp0 GLdouble x,
				register __fp1 GLdouble y )
{
	glVertex2d(x,y);
}
void APIENTRY smglVertex2f(register __fp0 GLfloat x,
				register __fp1 GLfloat y )
{
	glVertex2f(x,y);
}
void APIENTRY smglVertex2i(register __d0 GLint x,
				register __d1 GLint y )
{
	glVertex2i(x,y);
}
void APIENTRY smglVertex2s(register __d0 GLshort x,
				register __d1 GLshort y )
{
	glVertex2s(x,y);
}

void APIENTRY smglVertex3d(register __fp0 GLdouble x,
				register __fp1 GLdouble y,
				register __fp2 GLdouble z )
{
	glVertex3d(x,y,z);
}
void APIENTRY smglVertex3f(register __fp0 GLfloat x,
				register __fp1 GLfloat y,
				register __fp2 GLfloat z )
{
	glVertex3f(x,y,z);
}
void APIENTRY smglVertex3i(register __d0 GLint x,
				register __d1 GLint y,
				register __d2 GLint z )
{
	glVertex3i(x,y,z);
}
void APIENTRY smglVertex3s(register __d0 GLshort x,
				register __d1 GLshort y,
				register __d2 GLshort z )
{
	glVertex3s(x,y,z);
}

void APIENTRY smglVertex4d(register __fp0 GLdouble x,
				register __fp1 GLdouble y,
				register __fp2 GLdouble z,
				register __fp3 GLdouble w )
{
	glVertex4d(x,y,z,w);
}
void APIENTRY smglVertex4f(register __fp0 GLfloat x,
				register __fp1 GLfloat y,
				register __fp2 GLfloat z,
				register __fp3 GLfloat w )
{
	glVertex4f(x,y,z,w);
}
void APIENTRY smglVertex4i(register __d0 GLint x,
				register __d1 GLint y,
				register __d2 GLint z,
				register __d3 GLint w )
{
	glVertex4i(x,y,z,w);
}
void APIENTRY smglVertex4s(register __d0 GLshort x,
				register __d1 GLshort y,
				register __d2 GLshort z,
				register __d3 GLshort w )
{
	glVertex4s(x,y,z,w);
}

void APIENTRY smglVertex2dv(register __a0 const GLdouble *v )
{
	glVertex2dv(v);
}
void APIENTRY smglVertex2fv(register __a0 const GLfloat *v )
{
	glVertex2fv(v);
}
void APIENTRY smglVertex2iv(register __a0 const GLint *v )
{
	glVertex2iv(v);
}
void APIENTRY smglVertex2sv(register __a0 const GLshort *v )
{
	glVertex2sv(v);
}

void APIENTRY smglVertex3dv(register __a0 const GLdouble *v )
{
	glVertex3dv(v);
}
void APIENTRY smglVertex3fv(register __a0 const GLfloat *v )
{
	glVertex3fv(v);
}
void APIENTRY smglVertex3iv(register __a0 const GLint *v )
{
	glVertex3iv(v);
}
void APIENTRY smglVertex3sv(register __a0 const GLshort *v )
{
	glVertex3sv(v);
}

void APIENTRY smglVertex4dv(register __a0 const GLdouble *v )
{
	glVertex4dv(v);
}
void APIENTRY smglVertex4fv(register __a0 const GLfloat *v )
{
	glVertex4fv(v);
}
void APIENTRY smglVertex4iv(register __a0 const GLint *v )
{
	glVertex4iv(v);
}
void APIENTRY smglVertex4sv(register __a0 const GLshort *v )
{
	glVertex4sv(v);
}

void APIENTRY smglNormal3b(register __d0 GLbyte nx,
				register __d1 GLbyte ny,
				register __d2 GLbyte nz )
{
	glNormal3b(nx,ny,nz);
}
void APIENTRY smglNormal3d(register __fp0 GLdouble nx,
				register __fp1 GLdouble ny,
				register __fp2 GLdouble nz )
{
	glNormal3d(nx,ny,nz);
}
void APIENTRY smglNormal3f(register __fp0 GLfloat nx,
				register __fp1 GLfloat ny,
				register __fp2 GLfloat nz )
{
	glNormal3f(nx,ny,nz);
}
void APIENTRY smglNormal3i(register __d0 GLint nx,
				register __d1 GLint ny,
				register __d2 GLint nz )
{
	glNormal3i(nx,ny,nz);
}
void APIENTRY smglNormal3s(register __d0 GLshort nx,
				register __d1 GLshort ny,
				register __d2 GLshort nz )
{
	glNormal3s(nx,ny,nz);
}

void APIENTRY smglNormal3bv(register __a0 const GLbyte *v )
{
	glNormal3bv(v);
}
void APIENTRY smglNormal3dv(register __a0 const GLdouble *v )
{
	glNormal3dv(v);
}
void APIENTRY smglNormal3fv(register __a0 const GLfloat *v )
{
	glNormal3fv(v);
}
void APIENTRY smglNormal3iv(register __a0 const GLint *v )
{
	glNormal3iv(v);
}
void APIENTRY smglNormal3sv(register __a0 const GLshort *v )
{
	glNormal3sv(v);
}

void APIENTRY smglIndexd(register __fp0 GLdouble c )
{
	glIndexd(c);
}
void APIENTRY smglIndexf(register __fp0 GLfloat c )
{
	glIndexf(c);
}
void APIENTRY smglIndexi(register __d0 GLint c )
{
	glIndexi(c);
}
void APIENTRY smglIndexs(register __d0 GLshort c )
{
	glIndexs(c);
}
void APIENTRY smglIndexub( register __d0 GLubyte c )
{
	glIndexub(c);
}

void APIENTRY smglIndexdv(register __a0 const GLdouble *c )
{
	glIndexdv(c);
}
void APIENTRY smglIndexfv(register __a0 const GLfloat *c )
{
	glIndexfv(c);
}
void APIENTRY smglIndexiv(register __a0 const GLint *c )
{
	glIndexiv(c);
}
void APIENTRY smglIndexsv(register __a0 const GLshort *c )
{
	glIndexsv(c);
}
void APIENTRY smglIndexubv( register __a0 const GLubyte *c )
{
	glIndexubv(c);
}

void APIENTRY smglColor3b(register __d0 GLbyte red,
			       register __d1 GLbyte green,
			       register __d2 GLbyte blue )
{
	glColor3b(red,green,blue);
}
void APIENTRY smglColor3d(register __fp0 GLdouble red,
			       register __fp1 GLdouble green,
			       register __fp2 GLdouble blue )
{
	glColor3d(red,green,blue);
}
void APIENTRY smglColor3f(register __fp0 GLfloat red,
			       register __fp1 GLfloat green,
			       register __fp2 GLfloat blue )
{
	glColor3f(red,green,blue);
}
void APIENTRY smglColor3i(register __d0 GLint red,
			       register __d1 GLint green,
			       register __d2 GLint blue )
{
	glColor3i(red,green,blue);
}
void APIENTRY smglColor3s(register __d0 GLshort red,
			       register __d1 GLshort green,
			       register __d2 GLshort blue )
{
	glColor3s(red,green,blue);
}
void APIENTRY smglColor3ub(register __d0 GLubyte red,
				register __d1 GLubyte green,
				register __d2 GLubyte blue )
{
	glColor3ub(red,green,blue);
}
void APIENTRY smglColor3ui(register __d0 GLuint red,
				register __d1 GLuint green,
				register __d2 GLuint blue )
{
	glColor3ui(red,green,blue);
}
void APIENTRY smglColor3us(register __d0 GLushort red,
				register __d1 GLushort green,
				register __d2 GLushort blue )
{
	glColor3us(red,green,blue);
}

void APIENTRY smglColor4b(register __d0 GLbyte red,
			       register __d1 GLbyte green,
			       register __d2 GLbyte blue,
			       register __d3 GLbyte alpha )
{
	glColor4b(red,green,blue,alpha);
}
void APIENTRY smglColor4d(register __fp0 GLdouble red,
			       register __fp1 GLdouble green,
			       register __fp2 GLdouble blue,
			       register __fp3 GLdouble alpha )
{
	glColor4d(red,green,blue,alpha);
}
void APIENTRY smglColor4f(register __fp0 GLfloat red,
			       register __fp1 GLfloat green,
			       register __fp2 GLfloat blue,
			       register __fp3 GLfloat alpha )
{
	glColor4f(red,green,blue,alpha);
}
void APIENTRY smglColor4i(register __d0 GLint red,
			       register __d1 GLint green,
			       register __d2 GLint blue,
			       register __d3 GLint alpha )
{
	glColor4i(red,green,blue,alpha);
}
void APIENTRY smglColor4s(register __d0 GLshort red,
			       register __d1 GLshort green,
			       register __d2 GLshort blue,
			       register __d3 GLshort alpha )
{
	glColor4s(red,green,blue,alpha);
}
void APIENTRY smglColor4ub(register __d0 GLubyte red,
				register __d1 GLubyte green,
				register __d2 GLubyte blue,
				register __d3 GLubyte alpha )
{
	glColor4ub(red,green,blue,alpha);
}
void APIENTRY smglColor4ui(register __d0 GLuint red,
				register __d1 GLuint green,
				register __d2 GLuint blue,
				register __d3 GLuint alpha )
{
	glColor4ui(red,green,blue,alpha);
}
void APIENTRY smglColor4us(register __d0 GLushort red,
				register __d1 GLushort green,
				register __d2 GLushort blue,
				register __d3 GLushort alpha )
{
	glColor4us(red,green,blue,alpha);
}

void APIENTRY smglColor3bv(register __a0 const GLbyte *v )
{
	glColor3bv(v);
}
void APIENTRY smglColor3dv(register __a0 const GLdouble *v )
{
	glColor3dv(v);
}
void APIENTRY smglColor3fv(register __a0 const GLfloat *v )
{
	glColor3fv(v);
}
void APIENTRY smglColor3iv(register __a0 const GLint *v )
{
	glColor3iv(v);
}
void APIENTRY smglColor3sv(register __a0 const GLshort *v )
{
	glColor3sv(v);
}
void APIENTRY smglColor3ubv(register __a0 const GLubyte *v )
{
	glColor3ubv(v);
}
void APIENTRY smglColor3uiv(register __a0 const GLuint *v )
{
	glColor3uiv(v);
}
void APIENTRY smglColor3usv(register __a0 const GLushort *v )
{
	glColor3usv(v);
}

void APIENTRY smglColor4bv(register __a0 const GLbyte *v )
{
	glColor4bv(v);
}
void APIENTRY smglColor4dv(register __a0 const GLdouble *v )
{
	glColor4dv(v);
}
void APIENTRY smglColor4fv(register __a0 const GLfloat *v )
{
	glColor4fv(v);
}
void APIENTRY smglColor4iv(register __a0 const GLint *v )
{
	glColor4iv(v);
}
void APIENTRY smglColor4sv(register __a0 const GLshort *v )
{
	glColor4sv(v);
}
void APIENTRY smglColor4ubv(register __a0 const GLubyte *v )
{
	glColor4ubv(v);
}
void APIENTRY smglColor4uiv(register __a0 const GLuint *v )
{
	glColor4uiv(v);
}
void APIENTRY smglColor4usv(register __a0 const GLushort *v )
{
	glColor4usv(v);
}

void APIENTRY smglTexCoord1d(register __fp0 GLdouble s )
{
	glTexCoord1d(s);
}
void APIENTRY smglTexCoord1f(register __fp0 GLfloat s )
{
	glTexCoord1f(s);
}
void APIENTRY smglTexCoord1i(register __d0 GLint s )
{
	glTexCoord1i(s);
}
void APIENTRY smglTexCoord1s(register __d0 GLshort s )
{
	glTexCoord1s(s);
}

void APIENTRY smglTexCoord2d(register __fp0 GLdouble s,
				  register __fp1 GLdouble t )
{
	glTexCoord2d(s,t);
}
void APIENTRY smglTexCoord2f(register __fp0 GLfloat s,
				  register __fp1 GLfloat t )
{
	glTexCoord2f(s,t);
}
void APIENTRY smglTexCoord2i(register __d0 GLint s,
				  register __d1 GLint t )
{
	glTexCoord2i(s,t);
}
void APIENTRY smglTexCoord2s(register __d0 GLshort s,
				  register __d1 GLshort t )
{
	glTexCoord2s(s,t);
}

void APIENTRY smglTexCoord3d(register __fp0 GLdouble s,
				  register __fp1 GLdouble t,
				  register __fp2 GLdouble r )
{
	glTexCoord3d(s,t,r);
}
void APIENTRY smglTexCoord3f(register __fp0 GLfloat s,
				  register __fp1 GLfloat t,
				  register __fp2 GLfloat r )
{
	glTexCoord3f(s,t,r);
}
void APIENTRY smglTexCoord3i(register __d0 GLint s,
				  register __d1 GLint t,
				  register __d2 GLint r )
{
	glTexCoord3i(s,t,r);
}
void APIENTRY smglTexCoord3s(register __d0 GLshort s,
				  register __d1 GLshort t,
				  register __d2 GLshort r )
{
	glTexCoord3s(s,t,r);
}

void APIENTRY smglTexCoord4d(register __fp0 GLdouble s,
				  register __fp1 GLdouble t,
				  register __fp2 GLdouble r,
				  register __fp3 GLdouble q )
{
	glTexCoord4d(s,t,r,q);
}
void APIENTRY smglTexCoord4f(register __fp0 GLfloat s,
				  register __fp1 GLfloat t,
				  register __fp2 GLfloat r,
				  register __fp3 GLfloat q )
{
	glTexCoord4f(s,t,r,q);
}
void APIENTRY smglTexCoord4i(register __d0 GLint s,
				  register __d1 GLint t,
				  register __d2 GLint r,
				  register __d3 GLint q )
{
	glTexCoord4i(s,t,r,q);
}
void APIENTRY smglTexCoord4s(register __d0 GLshort s,
				  register __d1 GLshort t,
				  register __d2 GLshort r,
				  register __d3 GLshort q )
{
	glTexCoord4s(s,t,r,q);
}

void APIENTRY smglTexCoord1dv(register __a0 const GLdouble *v )
{
	glTexCoord1dv(v);
}
void APIENTRY smglTexCoord1fv(register __a0 const GLfloat *v )
{
	glTexCoord1fv(v);
}
void APIENTRY smglTexCoord1iv(register __a0 const GLint *v )
{
	glTexCoord1iv(v);
}
void APIENTRY smglTexCoord1sv(register __a0 const GLshort *v )
{
	glTexCoord1sv(v);
}

void APIENTRY smglTexCoord2dv(register __a0 const GLdouble *v )
{
	glTexCoord2dv(v);
}
void APIENTRY smglTexCoord2fv(register __a0 const GLfloat *v )
{
	glTexCoord2fv(v);
}
void APIENTRY smglTexCoord2iv(register __a0 const GLint *v )
{
	glTexCoord2iv(v);
}
void APIENTRY smglTexCoord2sv(register __a0 const GLshort *v )
{
	glTexCoord2sv(v);
}

void APIENTRY smglTexCoord3dv(register __a0 const GLdouble *v )
{
	glTexCoord3dv(v);
}
void APIENTRY smglTexCoord3fv(register __a0 const GLfloat *v )
{
	glTexCoord3fv(v);
}
void APIENTRY smglTexCoord3iv(register __a0 const GLint *v )
{
	glTexCoord3iv(v);
}
void APIENTRY smglTexCoord3sv(register __a0 const GLshort *v )
{
	glTexCoord3sv(v);
}

void APIENTRY smglTexCoord4dv(register __a0 const GLdouble *v )
{
	glTexCoord4dv(v);
}
void APIENTRY smglTexCoord4fv(register __a0 const GLfloat *v )
{
	glTexCoord4fv(v);
}
void APIENTRY smglTexCoord4iv(register __a0 const GLint *v )
{
	glTexCoord4iv(v);
}
void APIENTRY smglTexCoord4sv(register __a0 const GLshort *v )
{
	glTexCoord4sv(v);
}

void APIENTRY smglRasterPos2d(register __fp0 GLdouble x,
				   register __fp1 GLdouble y )
{
	glRasterPos2d(x,y);
}
void APIENTRY smglRasterPos2f(register __fp0 GLfloat x,
				   register __fp1 GLfloat y )
{
	glRasterPos2f(x,y);
}
void APIENTRY smglRasterPos2i(register __d0 GLint x,
				   register __d1 GLint y )
{
	glRasterPos2i(x,y);
}
void APIENTRY smglRasterPos2s(register __d0 GLshort x,
				   register __d1 GLshort y )
{
	glRasterPos2s(x,y);
}

void APIENTRY smglRasterPos3d(register __fp0 GLdouble x,
				   register __fp1 GLdouble y,
				   register __fp2 GLdouble z )
{
	glRasterPos3d(x,y,z);
}
void APIENTRY smglRasterPos3f(register __fp0 GLfloat x,
				   register __fp1 GLfloat y,
				   register __fp2 GLfloat z )
{
	glRasterPos3f(x,y,z);
}
void APIENTRY smglRasterPos3i(register __d0 GLint x,
				   register __d1 GLint y,
				   register __d2 GLint z )
{
	glRasterPos3i(x,y,z);
}
void APIENTRY smglRasterPos3s(register __d0 GLshort x,
				   register __d1 GLshort y,
				   register __d2 GLshort z )
{
	glRasterPos3s(x,y,z);
}

void APIENTRY smglRasterPos4d(register __fp0 GLdouble x,
				   register __fp1 GLdouble y,
				   register __fp2 GLdouble z,
				   register __fp3 GLdouble w )
{
	glRasterPos4d(x,y,z,w);
}
void APIENTRY smglRasterPos4f(register __fp0 GLfloat x,
				   register __fp1 GLfloat y,
				   register __fp2 GLfloat z,
				   register __fp3 GLfloat w )
{
	glRasterPos4f(x,y,z,w);
}
void APIENTRY smglRasterPos4i(register __d0 GLint x,
				   register __d1 GLint y,
				   register __d2 GLint z,
				   register __d3 GLint w )
{
	glRasterPos4i(x,y,z,w);
}
void APIENTRY smglRasterPos4s(register __d0 GLshort x,
				   register __d1 GLshort y,
				   register __d2 GLshort z,
				   register __d3 GLshort w )
{
	glRasterPos4s(x,y,z,w);
}

void APIENTRY smglRasterPos2dv(register __a0 const GLdouble *v )
{
	glRasterPos2dv(v);
}
void APIENTRY smglRasterPos2fv(register __a0 const GLfloat *v )
{
	glRasterPos2fv(v);
}
void APIENTRY smglRasterPos2iv(register __a0 const GLint *v )
{
	glRasterPos2iv(v);
}
void APIENTRY smglRasterPos2sv(register __a0 const GLshort *v )
{
	glRasterPos2sv(v);
}

void APIENTRY smglRasterPos3dv(register __a0 const GLdouble *v )
{
	glRasterPos3dv(v);
}
void APIENTRY smglRasterPos3fv(register __a0 const GLfloat *v )
{
	glRasterPos3fv(v);
}
void APIENTRY smglRasterPos3iv(register __a0 const GLint *v )
{
	glRasterPos3iv(v);
}
void APIENTRY smglRasterPos3sv(register __a0 const GLshort *v )
{
	glRasterPos3sv(v);
}

void APIENTRY smglRasterPos4dv(register __a0 const GLdouble *v )
{
	glRasterPos4dv(v);
}
void APIENTRY smglRasterPos4fv(register __a0 const GLfloat *v )
{
	glRasterPos4fv(v);
}
void APIENTRY smglRasterPos4iv(register __a0 const GLint *v )
{
	glRasterPos4iv(v);
}
void APIENTRY smglRasterPos4sv(register __a0 const GLshort *v )
{
	glRasterPos4sv(v);
}

void APIENTRY smglRectd(register __fp0 GLdouble x1,
			     register __fp1 GLdouble y1,
			     register __fp2 GLdouble x2,
			     register __fp3 GLdouble y2 )
{
	glRectd(x1,y1,x2,y2);
}
void APIENTRY smglRectf(register __fp0 GLfloat x1,
			     register __fp1 GLfloat y1,
			     register __fp2 GLfloat x2,
			     register __fp3 GLfloat y2 )
{
	glRectf(x1,y1,x2,y2);
}
void APIENTRY smglRecti(register __d0 GLint x1,
			     register __d1 GLint y1,
			     register __d2 GLint x2,
			     register __d3 GLint y2 )
{
	glRecti(x1,y1,x2,y2);
}
void APIENTRY smglRects(register __d0 GLshort x1,
			     register __d1 GLshort y1,
			     register __d2 GLshort x2,
			     register __d3 GLshort y2 )
{
	glRects(x1,y1,x2,y2);
}

void APIENTRY smglRectdv(register __a0 const GLdouble *v1,
			      register __a1 const GLdouble *v2 )
{
	glRectdv(v1,v2);
}
void APIENTRY smglRectfv(register __a0 const GLfloat *v1,
			      register __a1 const GLfloat *v2 )
{
	glRectfv(v1,v2);
}
void APIENTRY smglRectiv(register __a0 const GLint *v1,
			      register __a1 const GLint *v2 )
{
	glRectiv(v1,v2);
}
void APIENTRY smglRectsv(register __a0 const GLshort *v1,
			      register __a1  const GLshort *v2 )
{
	glRectsv(v1,v2);
}


/*
 * Vertex Arrays  (1.1)
 */

void APIENTRY smglVertexPointer(register __d0 GLint size,
				     register __d1 GLenum type,
				     register __d2 GLsizei stride,
				     register __a0 const GLvoid *ptr )
{
	glVertexPointer(size,type,stride,ptr);
}

void APIENTRY smglNormalPointer(register __d0 GLenum type,
				     register __d1 GLsizei stride,
				     register __a0 const GLvoid *ptr )
{
	glNormalPointer(type,stride,ptr);
}

void APIENTRY smglColorPointer(register __d0 GLint size,
				    register __d1 GLenum type,
				    register __d2 GLsizei stride,
				    register __a0 const GLvoid *ptr )
{
	glColorPointer(size,type,stride,ptr);
}

void APIENTRY smglIndexPointer(register __d0 GLenum type,
				    register __d1 GLsizei stride,
				    register __a0 const GLvoid *ptr )
{
	glIndexPointer(type,stride,ptr);
}

void APIENTRY smglTexCoordPointer(register __d0 GLint size,
				       register __d1 GLenum type,
				       register __d2 GLsizei stride,
				       register __a0 const GLvoid *ptr )
{
	glTexCoordPointer(size,type,stride,ptr);
}

void APIENTRY smglEdgeFlagPointer(register __d0 GLsizei stride,
				       register __a0 const GLboolean *ptr )
{
	glEdgeFlagPointer(stride,ptr);
}

void APIENTRY smglGetPointerv(register __d0 GLenum pname,
				   register __a0 GLvoid **params )
{
	glGetPointerv(pname,params);
}

void APIENTRY smglArrayElement(register __d0 GLint i )
{
	glArrayElement(i);
}

void APIENTRY smglDrawArrays(register __d0 GLenum mode,
				  register __d1 GLint first,
				  register __d2 GLsizei count )
{
	glDrawArrays(mode,first,count);
}

void APIENTRY smglDrawElements(register __d0 GLenum mode,
				    register __d1 GLsizei count,
				    register __d2 GLenum type,
				    register __a0 const GLvoid *indices )
{
	glDrawElements(mode,count,type,indices);
}

void APIENTRY smglInterleavedArrays(register __d0 GLenum format,
					 register __d1 GLsizei stride,
					 register __a0 const GLvoid *pointer )
{
	glInterleavedArrays(format,stride,pointer);
}


/*
 * Lighting
 */

void APIENTRY smglShadeModel(register __d0 GLenum mode )
{
	glShadeModel(mode);
}

void APIENTRY smglLightf(register __d0 GLenum light,
			      register __d1 GLenum pname,
			      register __fp0 GLfloat param )
{
	glLightf(light,pname,param);
}
void APIENTRY smglLighti(register __d0 GLenum light,
			      register __d1 GLenum pname,
			      register __d2 GLint param )
{
	glLighti(light,pname,param);
}
void APIENTRY smglLightfv(register __d0 GLenum light,
			       register __d1 GLenum pname,
			       register __a0 const GLfloat *params )
{
	glLightfv(light,pname,params);
}
void APIENTRY smglLightiv(register __d0 GLenum light,
			       register __d1 GLenum pname,
			       register __a0 const GLint *params )
{
	glLightiv(light,pname,params);
}

void APIENTRY smglGetLightfv(register __d0 GLenum light,
				  register __d1 GLenum pname,
				  register __a0 GLfloat *params )
{
	glGetLightfv(light,pname,params);
}
void APIENTRY smglGetLightiv(register __d0 GLenum light,
				  register __d1 GLenum pname,
				  register __a0 GLint *params )
{
	glGetLightiv(light,pname,params);
}

void APIENTRY smglLightModelf(register __d0 GLenum pname,
				   register __fp0  GLfloat param )
{
	glLightModelf(pname,param);
}
void APIENTRY smglLightModeli(register __d0 GLenum pname,
				   register __d1 GLint param )
{
	glLightModeli(pname,param);
}
void APIENTRY smglLightModelfv(register __d0 GLenum pname,
				    register __a0 const GLfloat *params )
{
	glLightModelfv(pname,params);
}
void APIENTRY smglLightModeliv(register __d0 GLenum pname,
				    register __a0 const GLint *params )
{
	glLightModeliv(pname,params);
}

void APIENTRY smglMaterialf(register __d0 GLenum face,
				 register __d1 GLenum pname,
				 register __fp0 GLfloat param )
{
	glMaterialf(face,pname,param);
}
void APIENTRY smglMateriali(register __d0 GLenum face,
				 register __d1 GLenum pname,
				 register __d2 GLint param )
{
	glMateriali(face,pname,param);
}
void APIENTRY smglMaterialfv(register __d0 GLenum face,
				  register __d1 GLenum pname,
				  register __a0 const GLfloat *params )
{
	glMaterialfv(face,pname,params);
}
void APIENTRY smglMaterialiv(register __d0 GLenum face,
				  register __d1 GLenum pname,
				  register __a0 const GLint *params )
{
	glMaterialiv(face,pname,params);
}

void APIENTRY smglGetMaterialfv(register __d0 GLenum face,
				     register __d1 GLenum pname,
				     register __a0 GLfloat *params )
{
	glGetMaterialfv(face,pname,params);
}
void APIENTRY smglGetMaterialiv(register __d0 GLenum face,
				     register __d1 GLenum pname,
				     register __a0 GLint *params )
{
	glGetMaterialiv(face,pname,params);
}

void APIENTRY smglColorMaterial(register __d0 GLenum face,
				     register __d1 GLenum mode )
{
	glColorMaterial(face,mode);
}




/*
 * Raster functions
 */

void APIENTRY smglPixelZoom(register __fp0 GLfloat xfactor,
				 register __fp1 GLfloat yfactor )
{
	glPixelZoom(xfactor,yfactor);
}

void APIENTRY smglPixelStoref(register __d0 GLenum pname,
				   register __fp0 GLfloat param )
{
	glPixelStoref(pname,param);
}
void APIENTRY smglPixelStorei(register __d0 GLenum pname,
				   register __d1 GLint param )
{
	glPixelStorei(pname,param);
}

void APIENTRY smglPixelTransferf(register __d0 GLenum pname,
				      register __fp0 GLfloat param )
{
	glPixelTransferf(pname,param);
}
void APIENTRY smglPixelTransferi(register __d0 GLenum pname,
				      register __d1 GLint param )
{
	glPixelTransferi(pname,param);
}

void APIENTRY smglPixelMapfv(register __d0 GLenum map,
				  register __d1 GLint mapsize,
				  register __a0 const GLfloat *values )
{
	glPixelMapfv(map,mapsize,values);
}
void APIENTRY smglPixelMapuiv(register __d0 GLenum map,
				   register __d1 GLint mapsize,
				   register __a0 const GLuint *values )
{
	glPixelMapuiv(map,mapsize,values);
}
void APIENTRY smglPixelMapusv(register __d0 GLenum map,
				   register __d1 GLint mapsize,
				   register __a0 const GLushort *values )
{
	glPixelMapusv(map,mapsize,values);
}

void APIENTRY smglGetPixelMapfv(register __d0 GLenum map,
				     register __a0 GLfloat *values )
{
	glGetPixelMapfv(map,values);
}
void APIENTRY smglGetPixelMapuiv(register __d0 GLenum map,
				      register __a0 GLuint *values )
{
	glGetPixelMapuiv(map,values);
}
void APIENTRY smglGetPixelMapusv(register __d0 GLenum map,
				      register __a0 GLushort *values )
{
	glGetPixelMapusv(map,values);
}

void APIENTRY smglBitmap(register __d0 GLsizei width,
			      register __d1 GLsizei height,
			      register __fp0 GLfloat xorig,
			      register __fp1 GLfloat yorig,
			      register __fp2 GLfloat xmove,
			      register __fp3 GLfloat ymove,
			      register __a0 const GLubyte *bitmap )
{
	glBitmap(width,height,xorig,yorig,xmove,ymove,bitmap);
}

void APIENTRY smglReadPixels(register __d0 GLint x,
				  register __d1 GLint y,
				  register __d2 GLsizei width,
				  register __d3 GLsizei height,
				  register __d4 GLenum format,
				  register __d5 GLenum type,
				  register __a0 GLvoid *pixels )
{
	glReadPixels(x,y,width,height,format,type,pixels);
}

void APIENTRY smglDrawPixels(register __d0 GLsizei width,
				  register __d1 GLsizei height,
				  register __d2 GLenum format,
				  register __d3 GLenum type,
				  register __a0 const GLvoid *pixels )
{
	glDrawPixels(width,height,format,type,pixels);
}

void APIENTRY smglCopyPixels(register __d0 GLint x,
				  register __d1 GLint y,
				  register __d2 GLsizei width,
				  register __d3 GLsizei height,
				  register __d4 GLenum type )
{
	glCopyPixels(x,y,width,height,type);
}



/*
 * Stenciling
 */

void APIENTRY smglStencilFunc(register __d0 GLenum func,
				   register __d1 GLint ref,
				   register __d2 GLuint mask )
{
	glStencilFunc(func,ref,mask);
}

void APIENTRY smglStencilMask(register __d0 GLuint mask )
{
	glStencilMask(mask);
}

void APIENTRY smglStencilOp(register __d0 GLenum fail,
				 register __d1 GLenum zfail,
				 register __d2 GLenum zpass )
{
	glStencilOp(fail,zfail,zpass);
}

void APIENTRY smglClearStencil(register __d0 GLint s )
{
	glClearStencil(s);
}



/*
 * Texture mapping
 */

void APIENTRY smglTexGend(register __d0 GLenum coord,
			       register __d1 GLenum pname,
			       register __fp0 GLdouble param )
{
	glTexGend(coord,pname,param);
}
void APIENTRY smglTexGenf(register __d0 GLenum coord,
			       register __d1 GLenum pname,
			       register __fp0 GLfloat param )
{
	glTexGenf(coord,pname,param);
}
void APIENTRY smglTexGeni(register __d0 GLenum coord,
			       register __d1 GLenum pname,
			       register __d2 GLint param )
{
	glTexGeni(coord,pname,param);
}

void APIENTRY smglTexGendv(register __d0 GLenum coord,
				register __d1 GLenum pname,
				register __a0 const GLdouble *params )
{
	glTexGendv(coord,pname,params);
}
void APIENTRY smglTexGenfv(register __d0 GLenum coord,
				register __d1 GLenum pname,
				register __a0 const GLfloat *params )
{
	glTexGenfv(coord,pname,params);
}
void APIENTRY smglTexGeniv(register __d0 GLenum coord,
				register __d1 GLenum pname,
				register __a0 const GLint *params )
{
	glTexGeniv(coord,pname,params);
}

void APIENTRY smglGetTexGendv(register __d0 GLenum coord,
				   register __d1 GLenum pname,
				   register __a0 GLdouble *params )
{
	glGetTexGendv(coord,pname,params);
}
void APIENTRY smglGetTexGenfv(register __d0 GLenum coord,
				   register __d1 GLenum pname,
				   register __a0 GLfloat *params )
{
	glGetTexGenfv(coord,pname,params);
}
void APIENTRY smglGetTexGeniv(register __d0 GLenum coord,
				   register __d1 GLenum pname,
				   register __a0 GLint *params )
{
	glGetTexGeniv(coord,pname,params);
}


void APIENTRY smglTexEnvf(register __d0 GLenum target,
			       register __d1 GLenum pname,
			       register __fp0 GLfloat param )
{
	glTexEnvf(target,pname,param);
}
void APIENTRY smglTexEnvi(register __d0 GLenum target,
			       register __d1 GLenum pname,
			       register __d2 GLint param )
{
	glTexEnvi(target,pname,param);
}

void APIENTRY smglTexEnvfv(register __d0 GLenum target,
				register __d1 GLenum pname,
				register __a0 const GLfloat *params )
{
	glTexEnvfv(target,pname,params);
}
void APIENTRY smglTexEnviv(register __d0 GLenum target,
				register __d1 GLenum pname,
				register __a0 const GLint *params )
{
	glTexEnviv(target,pname,params);
}

void APIENTRY smglGetTexEnvfv(register __d0 GLenum target,
				   register __d1 GLenum pname,
				   register __a0 GLfloat *params )
{
	glGetTexEnvfv(target,pname,params);
}
void APIENTRY smglGetTexEnviv(register __d0 GLenum target,
				   register __d1 GLenum pname,
				   register __a0 GLint *params )
{
	glGetTexEnviv(target,pname,params);
}


void APIENTRY smglTexParameterf(register __d0 GLenum target,
				     register __d1 GLenum pname,
				     register __fp0 GLfloat param )
{
	glTexParameterf(target,pname,param);
}
void APIENTRY smglTexParameteri(register __d0 GLenum target,
				     register __d1 GLenum pname,
				     register __d2 GLint param )
{
	glTexParameteri(target,pname,param);
}

void APIENTRY smglTexParameterfv(register __d0 GLenum target,
				      register __d1 GLenum pname,
				      register __a0 const GLfloat *params )
{
	glTexParameterfv(target,pname,params);
}
void APIENTRY smglTexParameteriv(register __d0 GLenum target,
				      register __d1 GLenum pname,
				      register __a0 const GLint *params )
{
	glTexParameteriv(target,pname,params);
}

void APIENTRY smglGetTexParameterfv(register __d0 GLenum target,
					 register __d1 GLenum pname,
					 register __a0 GLfloat *params)
{
	glGetTexParameterfv(target,pname,params);
}
void APIENTRY smglGetTexParameteriv(register __d0 GLenum target,
					 register __d1 GLenum pname,
					 register __a0 GLint *params )
{
	glGetTexParameteriv(target,pname,params);
}

void APIENTRY smglGetTexLevelParameterfv(register __d0 GLenum target,
					      register __d1 GLint level,
					      register __d2 GLenum pname,
					      register __a0  GLfloat *params )
{
	glGetTexLevelParameterfv(target,level,pname,params);
}
void APIENTRY smglGetTexLevelParameteriv(register __d0 GLenum target,
					      register __d1  GLint level,
					      register __d2 GLenum pname,
					      register __a0  GLint *params )
{
	glGetTexLevelParameteriv(target,level,pname,params);
}


void APIENTRY smglTexImage1D(register __d0 GLenum target,
				  register __d1 GLint level,
				  register __d2 GLint components,
				  register __d3 GLsizei width,
				  register __d4 GLint border,
				  register __d5 GLenum format,
				  register __d6 GLenum type,
				  register __a0 const GLvoid *pixels )
{
	glTexImage1D(target,level,components,width,border,format,type,pixels);
}

void APIENTRY smglTexImage2D(register __d0 GLenum target,
				  register __d1 GLint level,
				  register __d2 GLint components,
				  register __d3 GLsizei width,
				  register __d4 GLsizei height,
				  register __d5 GLint border,
				  register __d6 GLenum format,
				  register __d7 GLenum type,
				  register __a0 const GLvoid *pixels )
{
	glTexImage2D(target,level,components,width,height,border,format,type,pixels);
}

void APIENTRY smglGetTexImage(register __d0 GLenum target,
				   register __d1 GLint level,
				   register __d2 GLenum format,
				   register __d3 GLenum type,
				   register __a0 GLvoid *pixels )
{
	glGetTexImage(target,level,format,type,pixels);
}


/*
 * 1.1 functions
 */


void APIENTRY smglGenTextures(register __d0 GLsizei n,
				   register __a0 GLuint *textures )
{
	glGenTextures(n,textures);
}

void APIENTRY smglDeleteTextures(register __d0 GLsizei n,
				      register __a0 const GLuint *textures)
{
	glDeleteTextures(n,textures);
}

void APIENTRY smglBindTexture(register __d0 GLenum target,
				   register __d1 GLuint texture )
{
	glBindTexture(target,texture);
}

void APIENTRY smglPrioritizeTextures(register __d0 GLsizei n,
					  register __a0 const GLuint *textures,
					  register __a1 const GLclampf *priorities )
{
	glPrioritizeTextures(n,textures,priorities);
}

GLboolean APIENTRY smglAreTexturesResident(register __d0 GLsizei n,
						register __a0 const GLuint *textures,
						register __a1 GLboolean *residences )
{
	return(glAreTexturesResident(n,textures,residences));
}

GLboolean APIENTRY smglIsTexture(register __d0 GLuint texture )
{
	return(glIsTexture(texture));
}

void APIENTRY smglTexSubImage1D(register __d0 GLenum target,
				     register __d1 GLint level,
				     register __d2 GLint xoffset,
				     register __d3 GLsizei width,
				     register __d4 GLenum format,
				     register __d5 GLenum type,
				     register __a0 const GLvoid *pixels )
{
	glTexSubImage1D(target,level,xoffset,width,format,type,pixels);
}

void APIENTRY smglTexSubImage2D(register __d0 GLenum target,
				     register __d1 GLint level,
				     register __d2 GLint xoffset,
				     register __d3 GLint yoffset,
				     register __d4 GLsizei width,
				     register __d5 GLsizei height,
				     register __d6 GLenum format,
				     register __d7 GLenum type,
				     register __a0 const GLvoid *pixels )
{
	glTexSubImage2D(target,level,xoffset,yoffset,width,height,format,type,pixels);
}

void APIENTRY smglCopyTexImage1D(register __d0 GLenum target,
				      register __d1 GLint level,
				      register __d2 GLenum internalformat,
				      register __d3 GLint x,
				      register __d4 GLint y,
				      register __d5 GLsizei width,
				      register __d6 GLint border )
{
	glCopyTexImage1D(target,level,internalformat,x,y,width,border);
}

void APIENTRY smglCopyTexImage2D(register __d0 GLenum target,
				      register __d1 GLint level,
				      register __d2 GLenum internalformat,
				      register __d3 GLint x,
				      register __d4 GLint y,
				      register __d5 GLsizei width,
				      register __d6 GLsizei height,
				      register __d7 GLint border )
{
	glCopyTexImage2D(target,level,internalformat,x,y,width,height,border);
}

void APIENTRY smglCopyTexSubImage1D(register __d0 GLenum target,
					 register __d1 GLint level,
					 register __d2 GLint xoffset,
					 register __d3 GLint x,
					 register __d4 GLint y,
					 register __d5 GLsizei width )
{
	glCopyTexSubImage1D(target,level,xoffset,x,y,width);
}

void APIENTRY smglCopyTexSubImage2D(register __d0 GLenum target,
					 register __d1 GLint level,
					 register __d2 GLint xoffset,
					 register __d3 GLint yoffset,
					 register __d4 GLint x,
					 register __d5 GLint y,
					 register __d6 GLsizei width,
					 register __d7 GLsizei height )
{
	glCopyTexSubImage2D(target,level,xoffset,yoffset,x,y,width,height);
}


/*
 * Evaluators
 */

void APIENTRY smglMap1d(register __d0 GLenum target,
			     register __fp0 GLdouble u1,
			     register __fp1 GLdouble u2,
			     register __d1 GLint stride,
			     register __d2 GLint order,
			     register __a0  const GLdouble *points )
{
	glMap1d(target,u1,u2,stride,order,points);
}

void APIENTRY smglMap1f(register __d0 GLenum target,
			     register __fp0 GLfloat u1,
			     register __fp1 GLfloat u2,
			     register __d1 GLint stride,
			     register __d2 GLint order,
			     register __a0 const GLfloat *points )
{
	glMap1f(target,u1,u2,stride,order,points);
}

void APIENTRY smglMap2d(register __d0 GLenum target,
			     register __fp0 GLdouble u1,
			     register __fp1 GLdouble u2,
			     register __d1 GLint ustride,
			     register __d2 GLint uorder,
			     register __fp2 GLdouble v1,
			     register __fp3 GLdouble v2,
			     register __d3 GLint vstride,
			     register __d4 GLint vorder,
			     register __a0 const GLdouble *points )
{
	glMap2d(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

void APIENTRY smglMap2f(register __d0 GLenum target,
			     register __fp0 GLfloat u1,
			     register __fp1 GLfloat u2,
			     register __d1 GLint ustride,
			     register __d2 GLint uorder,
			     register __fp2 GLfloat v1,
			     register __fp3 GLfloat v2,
			     register __d3 GLint vstride,
			     register __d4 GLint vorder,
			     register __a0 const GLfloat *points )
{
	glMap2f(target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points);
}

void APIENTRY smglGetMapdv(register __d0 GLenum target,
				register __d1 GLenum query,
				register __a0 GLdouble *v )
{
	glGetMapdv(target,query,v);
}
void APIENTRY smglGetMapfv(register __d0 GLenum target,
				register __d1 GLenum query,
				register __a0 GLfloat *v )
{
	glGetMapfv(target,query,v);
}
void APIENTRY smglGetMapiv(register __d0 GLenum target,
				register __d1 GLenum query,
				register __a0 GLint *v )
{
	glGetMapiv(target,query,v);
}

void APIENTRY smglEvalCoord1d(register __fp0 GLdouble u )
{
	glEvalCoord1d(u);
}
void APIENTRY smglEvalCoord1f(register __fp0 GLfloat u )
{
	glEvalCoord1f(u);
}

void APIENTRY smglEvalCoord1dv(register __a0 const GLdouble *u )
{
	glEvalCoord1dv(u);
}
void APIENTRY smglEvalCoord1fv(register __a0 const GLfloat *u )
{
	glEvalCoord1fv(u);
}

void APIENTRY smglEvalCoord2d(register __fp0 GLdouble u,
				   register __fp1 GLdouble v )
{
	glEvalCoord2d(u,v);
}
void APIENTRY smglEvalCoord2f(register __fp0 GLfloat u,
				   register __fp1  GLfloat v )
{
	glEvalCoord2f(u,v);
}

void APIENTRY smglEvalCoord2dv(register __a0 const GLdouble *u )
{
	glEvalCoord2dv(u);
}
void APIENTRY smglEvalCoord2fv(register __a0 const GLfloat *u )
{
	glEvalCoord2fv(u);
}

void APIENTRY smglMapGrid1d(register __d0 GLint un,
				 register __fp0 GLdouble u1,
				 register __fp1 GLdouble u2 )
{
	glMapGrid1d(un,u1,u2);
}
void APIENTRY smglMapGrid1f(register __d0 GLint un,
				 register __fp0 GLfloat u1,
				 register __fp1 GLfloat u2 )
{
	glMapGrid1f(un,u1,u2);
}

void APIENTRY smglMapGrid2d(register __d0 GLint un,
				 register __fp0 GLdouble u1,
				 register __fp1 GLdouble u2,
				 register __d1 GLint vn,
				 register __fp2 GLdouble v1,
				 register __fp3 GLdouble v2 )
{
	glMapGrid2d(un,u1,u2,vn,v1,v2);
}
void APIENTRY smglMapGrid2f(register __d0 GLint un,
				 register __fp0 GLfloat u1,
				 register __fp1 GLfloat u2,
				 register __d1 GLint vn,
				 register __fp2 GLfloat v1,
				 register __fp3 GLfloat v2 )
{
	glMapGrid2f(un,u1,u2,vn,v1,v2);
}

void APIENTRY smglEvalPoint1(register __d0 GLint i )
{
	glEvalPoint1(i);
}

void APIENTRY smglEvalPoint2(register __d0 GLint i,
				  register __d1 GLint j )
{
	glEvalPoint2(i,j);
}

void APIENTRY smglEvalMesh1(register __d0 GLenum mode,
				 register __d1 GLint i1,
				 register __d2 GLint i2 )
{
	glEvalMesh1(mode,i1,i2);
}

void APIENTRY smglEvalMesh2(register __d0 GLenum mode,
				 register __d1 GLint i1,
				 register __d2 GLint i2,
				 register __d3 GLint j1,
				 register __d4 GLint j2 )
{
	glEvalMesh2(mode,i1,i2,j1,j2);
}



/*
 * Fog
 */

void APIENTRY smglFogf(register __d0 GLenum pname,
			    register __fp0 GLfloat param )
{
	glFogf(pname,param);
}

void APIENTRY smglFogi(register __d0 GLenum pname,
			    register __d1 GLint param )
{
	glFogi(pname,param);
}

void APIENTRY smglFogfv(register __d0 GLenum pname,
			     register __a0 const GLfloat *params )
{
	glFogfv(pname,params);
}

void APIENTRY smglFogiv(register __d0 GLenum pname,
			     register __a0 const GLint *params )
{
	glFogiv(pname,params);
}



/*
 * Selection and Feedback
 */

void APIENTRY smglFeedbackBuffer(register __d0 GLsizei size,
				      register __d1 GLenum type,
				      register __a0  GLfloat *buffer )
{
	glFeedbackBuffer(size,type,buffer);
}

void APIENTRY smglPassThrough(register __fp0 GLfloat token )
{
	glPassThrough(token);
}

void APIENTRY smglSelectBuffer(register __d0 GLsizei size,
				    register __a0 GLuint *buffer )
{
	glSelectBuffer(size,buffer);
}

void APIENTRY smglInitNames(void )
{
	glInitNames();
}

void APIENTRY smglLoadName(register __d0 GLuint name )
{
	glLoadName(name);
}

void APIENTRY smglPushName(register __d0 GLuint name )
{
	glPushName(name);
}

void APIENTRY smglPopName(void )
{
	glPopName();
}



/*
 * 1.0 Extensions
 */

/* GL_EXT_blend_minmax */

void APIENTRY smglBlendEquationEXT(register __d0 GLenum mode )
{
	glBlendEquationEXT(mode);
}

/* GL_EXT_blend_color */

void APIENTRY smglBlendColorEXT(register __fp0 GLclampf red,
				     register __fp1 GLclampf green,
				     register __fp2 GLclampf blue,
				     register __fp3 GLclampf alpha )
{
	glBlendColorEXT(red,green,blue,alpha);
}


/* GL_EXT_polygon_offset */

void APIENTRY smglPolygonOffsetEXT(register __fp0 GLfloat factor,
					register __fp1 GLfloat bias )
{
	glPolygonOffsetEXT(factor,bias);
}

/* GL_EXT_vertex_array */

void APIENTRY smglVertexPointerEXT(register __d0 GLint size,
					register __d1 GLenum type,
					register __d2 GLsizei stride,
					register __d3 GLsizei count,
					register __a0 const GLvoid *ptr )
{
	glVertexPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglNormalPointerEXT(register __d0 GLenum type,
					register __d1 GLsizei stride,
					register __d2 GLsizei count,
					register __a0 const GLvoid *ptr )
{
	glNormalPointerEXT(type,stride,count,ptr);
}

void APIENTRY smglColorPointerEXT(register __d0 GLint size,
				       register __d1 GLenum type,
				       register __d2 GLsizei stride,
				       register __d3 GLsizei count,
				       register __a0 const GLvoid *ptr )
{
	glColorPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglIndexPointerEXT(register __d0 GLenum type,
				       register __d1 GLsizei stride,
				       register __d2 GLsizei count,
				       register __a0 const GLvoid *ptr )
{
	glIndexPointerEXT(type,stride,count,ptr);
}

void APIENTRY smglTexCoordPointerEXT(register __d0 GLint size,
					  register __d1 GLenum type,
					  register __d2 GLsizei stride,
					  register __d3 GLsizei count,
					  register __a0 const GLvoid *ptr )
{
	glTexCoordPointerEXT(size,type,stride,count,ptr);
}

void APIENTRY smglEdgeFlagPointerEXT(register __d0 GLsizei stride,
					  register __d1 GLsizei count,
					  register __a0 const GLboolean *ptr )
{
	glEdgeFlagPointerEXT(stride,count,ptr);
}

void APIENTRY smglGetPointervEXT(register __d0 GLenum pname,
				      register __a0 void **params )
{
	glGetPointervEXT(pname,params);
}

void APIENTRY smglArrayElementEXT(register __d0 GLint i )
{
	glArrayElementEXT(i);
}

void APIENTRY smglDrawArraysEXT(register __d0 GLenum mode,
				     register __d1 GLint first,
				     register __d2 GLsizei count )
{
	glDrawArraysEXT(mode,first,count);
}


/* GL_EXT_texture_object */

void APIENTRY smglGenTexturesEXT(register __d0 GLsizei n,
				      register __a0 GLuint *textures )
{
	glGenTexturesEXT(n,textures);
}

void APIENTRY smglDeleteTexturesEXT(register __d0 GLsizei n,
					 register __a0 const GLuint *textures)
{
	glDeleteTexturesEXT(n,textures);
}

void APIENTRY smglBindTextureEXT(register __d0  GLenum target,
				      register __d1 GLuint texture )
{
	glBindTextureEXT(target,texture);
}

void APIENTRY smglPrioritizeTexturesEXT(register __d0  GLsizei n,
					     register __a0 const GLuint *textures,
					     register __a1 const GLclampf *priorities )
{
	glPrioritizeTexturesEXT(n,textures,priorities);
}

GLboolean APIENTRY smglAreTexturesResidentEXT(register __d0 GLsizei n,
						   register __a0 const GLuint *textures,
						   register __a1 GLboolean *residences )
{
	return(glAreTexturesResidentEXT(n,textures,residences));
}

GLboolean APIENTRY smglIsTextureEXT( register __d0 GLuint texture )
{
	return(glIsTextureEXT(texture));
}



/* GL_EXT_texture3D */

void APIENTRY smglTexImage3DEXT(register __d0 GLenum target,
				     register __d1 GLint level,
				     register __d2 GLenum internalformat,
				     register __d3 GLsizei width,
				     register __d4 GLsizei height,
				     register __d5 GLsizei depth,
				     register __d6 GLint border,
				     register __d7 GLenum format,
				     register __a0 GLenum type,
				     register __a1 const GLvoid *pixels )
{
	glTexImage3DEXT(target,level,internalformat,width,height,depth,border,format,type,pixels);
}

void APIENTRY smglTexSubImage3DEXT(register __d0 GLenum target,
					register __d1 GLint level,
					register __d2 GLint xoffset,
					register __d3 GLint yoffset,
					register __d4 GLint zoffset,
					register __d5 GLsizei width,
					register __d6 GLsizei height,
					register __d7 GLsizei depth,
					register __a0 GLenum format,
					register __a1 GLenum type,
					register __a2 const GLvoid *pixels )
{
	glTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);
}

void APIENTRY smglCopyTexSubImage3DEXT(register __d0 GLenum target,
					    register __d1 GLint level,
					    register __d2 GLint xoffset,
					    register __d3 GLint yoffset,
					    register __d4 GLint zoffset,
					    register __d5 GLint x,
					    register __d6 GLint y,
					    register __d7 GLsizei width,
					    register __a0 GLsizei height )
{
	glCopyTexSubImage3DEXT(target,level,xoffset,yoffset,zoffset,x,y,width,height);
}

/* EXT_color_table */

void APIENTRY smglColorTableEXT( register __d0 GLenum target,
				      register __d1 GLenum internalformat,
				      register __d2 GLsizei width,
				      register __d3 GLenum format,
				      register __d4 GLenum type,
				      register __a0 const GLvoid *table )
{
	glColorTableEXT(target,internalformat,width,format,type,table);
}

void APIENTRY smglColorSubTableEXT( register __d0 GLenum target,
					 register __d1 GLsizei start,
					 register __d2 GLsizei count,
					 register __d3 GLenum format,
					 register __d4 GLenum type,
					 register __a0 const GLvoid *data )
{
	glColorSubTableEXT(target,start,count,format,type,data);
}

void APIENTRY smglGetColorTableEXT( register __d0 GLenum target,
					 register __d1 GLenum format,
					 register __d2 GLenum type,
					 register __a0 GLvoid *table )
{
	glGetColorTableEXT(target,format,type,table);
}

void APIENTRY smglGetColorTableParameterfvEXT( register __d0 GLenum target,
						    register __d1 GLenum pname,
						    register __a0 GLfloat *params )
{
	glGetColorTableParameterfvEXT(target,pname,params);
}

void APIENTRY smglGetColorTableParameterivEXT( register __d0 GLenum target,
						    register __d1 GLenum pname,
						    register __a0 GLint *params )
{
	glGetColorTableParameterivEXT(target,pname,params);
}


/* GL_SGIS_multitexture */

void APIENTRY smglMultiTexCoord1dSGIS(register __d0 GLenum target,
				      register __fp0 GLdouble s)
{
	glMultiTexCoord1dSGIS(target,s);
}
void APIENTRY smglMultiTexCoord1dvSGIS(register __d0 GLenum target,
				       register __a0 const GLdouble *v)
{
	glMultiTexCoord1dvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord1fSGIS(register __d0 GLenum target,
				      register __fp0 GLfloat s)
{
	glMultiTexCoord1fSGIS(target,s);
}
void APIENTRY smglMultiTexCoord1fvSGIS(register __d0 GLenum target,
				       register __a0 const GLfloat *v)
{
	glMultiTexCoord1fvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord1iSGIS(register __d0 GLenum target,
				      register __d1 GLint s)
{
	glMultiTexCoord1iSGIS(target,s);
}
void APIENTRY smglMultiTexCoord1ivSGIS(register __d0 GLenum target,
				       register __a0 const GLint *v)
{
	glMultiTexCoord1ivSGIS(target,v);
}
void APIENTRY smglMultiTexCoord1sSGIS(register __d0 GLenum target,
				      register __d1 GLshort s)
{
	glMultiTexCoord1sSGIS(target,s);
}
void APIENTRY smglMultiTexCoord1svSGIS(register __d0 GLenum target,
				       register __a0 const GLshort *v)
{
	glMultiTexCoord1svSGIS(target,v);
}
void APIENTRY smglMultiTexCoord2dSGIS(register __d0 GLenum target,
				      register __fp0 GLdouble s,
				      register __fp1 GLdouble t)
{
	glMultiTexCoord2dSGIS(target,s,t);
}
void APIENTRY smglMultiTexCoord2dvSGIS(register __d0 GLenum target,
				       register __a0 const GLdouble *v)
{
	glMultiTexCoord2dvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord2fSGIS(register __d0 GLenum target,
				      register __fp0 GLfloat s,
				      register __fp1 GLfloat t)
{
	glMultiTexCoord2fSGIS(target,s,t);
}
void APIENTRY smglMultiTexCoord2fvSGIS(register __d0 GLenum target,
				       register __a0 const GLfloat *v)
{
	glMultiTexCoord2fvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord2iSGIS(register __d0 GLenum target,
				      register __d1 GLint s,
				      register __d2 GLint t)
{
	glMultiTexCoord2iSGIS(target,s,t);
}
void APIENTRY smglMultiTexCoord2ivSGIS(register __d0 GLenum target,
				       register __a0 const GLint *v)
{
	glMultiTexCoord2ivSGIS(target,v);
}
void APIENTRY smglMultiTexCoord2sSGIS(register __d0 GLenum target,
				      register __d1 GLshort s,
				      register __d2 GLshort t)
{
	glMultiTexCoord2sSGIS(target,s,t);
}
void APIENTRY smglMultiTexCoord2svSGIS(register __d0 GLenum target,
				       register __a0 const GLshort *v)
{
	glMultiTexCoord2svSGIS(target,v);
}
void APIENTRY smglMultiTexCoord3dSGIS(register __d0 GLenum target,
				      register __fp0 GLdouble s,
				      register __fp1 GLdouble t,
				      register __fp2 GLdouble r)
{
	glMultiTexCoord3dSGIS(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3dvSGIS(register __d0 GLenum target,
				       register __a0 const GLdouble *v)
{
	glMultiTexCoord3dvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord3fSGIS(register __d0 GLenum target,
				      register __fp0 GLfloat s,
				      register __fp1 GLfloat t,
				      register __fp2 GLfloat r)
{
	glMultiTexCoord3fSGIS(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3fvSGIS(register __d0 GLenum target,
				       register __a0 const GLfloat *v)
{
	glMultiTexCoord3fvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord3iSGIS(register __d0 GLenum target,
				      register __d1 GLint s,
				      register __d2 GLint t,
				      register __d3 GLint r)
{
	glMultiTexCoord3iSGIS(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3ivSGIS(register __d0 GLenum target,
				       register __a0 const GLint *v)
{
	glMultiTexCoord3ivSGIS(target,v);
}
void APIENTRY smglMultiTexCoord3sSGIS(register __d0 GLenum target,
				      register __d1 GLshort s,
				      register __d2 GLshort t,
				      register __d3 GLshort r)
{
	glMultiTexCoord3sSGIS(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3svSGIS(register __d0 GLenum target,
				       register __a0 const GLshort *v)
{
	glMultiTexCoord3svSGIS(target,v);
}
void APIENTRY smglMultiTexCoord4dSGIS(register __d0 GLenum target,
				      register __fp0 GLdouble s,
				      register __fp1 GLdouble t,
				      register __fp2 GLdouble r,
				      register __fp3 GLdouble q)
{
	glMultiTexCoord4dSGIS(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4dvSGIS(register __d0 GLenum target,
				       register __a0 const GLdouble *v)
{
	glMultiTexCoord4dvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord4fSGIS(register __d0 GLenum target,
				      register __fp0 GLfloat s,
				      register __fp1 GLfloat t,
				      register __fp2 GLfloat r,
				      register __fp3 GLfloat q)
{
	glMultiTexCoord4fSGIS(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4fvSGIS(register __d0 GLenum target,
				       register __a0 const GLfloat *v)
{
	glMultiTexCoord4fvSGIS(target,v);
}
void APIENTRY smglMultiTexCoord4iSGIS(register __d0 GLenum target,
				      register __d1 GLint s,
				      register __d2 GLint t,
				      register __d3 GLint r,
				      register __d4 GLint q)
{
	glMultiTexCoord4iSGIS(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4ivSGIS(register __d0 GLenum target,
				       register __a0 const GLint *v)
{
	glMultiTexCoord4ivSGIS(target,v);
}
void APIENTRY smglMultiTexCoord4sSGIS(register __d0 GLenum target,
				      register __d1 GLshort s,
				      register __d2 GLshort t,
				      register __d3 GLshort r,
				      register __d4 GLshort q)
{
	glMultiTexCoord4sSGIS(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4svSGIS(register __d0 GLenum target,
				       register __a0 const GLshort *v)
{
	glMultiTexCoord4svSGIS(target,v);
}

void APIENTRY smglMultiTexCoordPointerSGIS(register __d0 GLenum target,
					   register __d1 GLint size,
					   register __d2 GLenum type,
					   register __d3 GLsizei stride,
					   register __a0 const GLvoid *pointer)
{
	glMultiTexCoordPointerSGIS(target,size,type,stride,pointer);
}

void APIENTRY smglSelectTextureSGIS(register __d0 GLenum target)
{
	glSelectTextureSGIS(target);
}

void APIENTRY smglSelectTextureCoordSetSGIS(register __d0 GLenum target)
{
	glSelectTextureCoordSetSGIS(target);
}


/* GL_EXT_multitexture */

void APIENTRY smglMultiTexCoord1dEXT(register __d0 GLenum target,
				     register __fp0 GLdouble s)
{
	glMultiTexCoord1dEXT(target,s);
}
void APIENTRY smglMultiTexCoord1dvEXT(register __d0 GLenum target,
				      register __a0 const GLdouble *v)
{
	glMultiTexCoord1dvEXT(target,v);
}
void APIENTRY smglMultiTexCoord1fEXT(register __d0 GLenum target,
				     register __fp0 GLfloat s)
{
	glMultiTexCoord1fEXT(target,s);
}
void APIENTRY smglMultiTexCoord1fvEXT(register __d0 GLenum target,
				      register __a0 const GLfloat *v)
{
	glMultiTexCoord1fvEXT(target,v);
}
void APIENTRY smglMultiTexCoord1iEXT(register __d0 GLenum target,
				     register __d1 GLint s)
{
	glMultiTexCoord1iEXT(target,s);
}
void APIENTRY smglMultiTexCoord1ivEXT(register __d0 GLenum target,
				      register __a0 const GLint *v)
{
	glMultiTexCoord1ivEXT(target,v);
}
void APIENTRY smglMultiTexCoord1sEXT(register __d0 GLenum target,
				     register __d1 GLshort s)
{
	glMultiTexCoord1sEXT(target,s);
}
void APIENTRY smglMultiTexCoord1svEXT(register __d0 GLenum target,
				      register __a0 const GLshort *v)
{
	glMultiTexCoord1svEXT(target,v);
}
void APIENTRY smglMultiTexCoord2dEXT(register __d0 GLenum target,
				     register __fp0 GLdouble s,
				     register __fp1 GLdouble t)
{
	glMultiTexCoord2dEXT(target,s,t);
}
void APIENTRY smglMultiTexCoord2dvEXT(register __d0 GLenum target,
				      register __a0 const GLdouble *v)
{
	glMultiTexCoord2dvEXT(target,v);
}
void APIENTRY smglMultiTexCoord2fEXT(register __d0 GLenum target,
				     register __fp0 GLfloat s,
				     register __fp1 GLfloat t)
{
	glMultiTexCoord2fEXT(target,s,t);
}
void APIENTRY smglMultiTexCoord2fvEXT(register __d0 GLenum target,
				      register __a0 const GLfloat *v)
{
	glMultiTexCoord2fvEXT(target,v);
}
void APIENTRY smglMultiTexCoord2iEXT(register __d0 GLenum target,
				     register __d1 GLint s,
				     register __d2 GLint t)
{
	glMultiTexCoord2iEXT(target,s,t);
}
void APIENTRY smglMultiTexCoord2ivEXT(register __d0 GLenum target,
				      register __a0 const GLint *v)
{
	glMultiTexCoord2ivEXT(target,v);
}
void APIENTRY smglMultiTexCoord2sEXT(register __d0 GLenum target,
				     register __d1 GLshort s,
				     register __d2 GLshort t)
{
	glMultiTexCoord2sEXT(target,s,t);
}
void APIENTRY smglMultiTexCoord2svEXT(register __d0 GLenum target,
				      register __a0 const GLshort *v)
{
	glMultiTexCoord2svEXT(target,v);
}
void APIENTRY smglMultiTexCoord3dEXT(register __d0 GLenum target,
				     register __fp0 GLdouble s,
				     register __fp1 GLdouble t,
				     register __fp2 GLdouble r)
{
	glMultiTexCoord3dEXT(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3dvEXT(register __d0 GLenum target,
				      register __a0 const GLdouble *v)
{
	glMultiTexCoord3dvEXT(target,v);
}
void APIENTRY smglMultiTexCoord3fEXT(register __d0 GLenum target,
				     register __fp0 GLfloat s,
				     register __fp1 GLfloat t,
				     register __fp2 GLfloat r)
{
	glMultiTexCoord3fEXT(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3fvEXT(register __d0 GLenum target,
				      register __a0 const GLfloat *v)
{
	glMultiTexCoord3fvEXT(target,v);
}
void APIENTRY smglMultiTexCoord3iEXT(register __d0 GLenum target,
				     register __d1 GLint s,
				     register __d2 GLint t,
				     register __d3 GLint r)
{
	glMultiTexCoord3iEXT(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3ivEXT(register __d0 GLenum target,
				      register __a0 const GLint *v)
{
	glMultiTexCoord3ivEXT(target,v);
}
void APIENTRY smglMultiTexCoord3sEXT(register __d0 GLenum target,
				     register __d1 GLshort s,
				     register __d2 GLshort t,
				     register __d3 GLshort r)
{
	glMultiTexCoord3sEXT(target,s,t,r);
}
void APIENTRY smglMultiTexCoord3svEXT(register __d0 GLenum target,
				      register __a0 const GLshort *v)
{
	glMultiTexCoord3svEXT(target,v);
}
void APIENTRY smglMultiTexCoord4dEXT(register __d0 GLenum target,
				     register __fp0 GLdouble s,
				     register __fp1 GLdouble t,
				     register __fp2 GLdouble r,
				     register __fp3 GLdouble q)
{
	glMultiTexCoord4dEXT(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4dvEXT(register __d0 GLenum target,
				      register __a0 const GLdouble *v)
{
	glMultiTexCoord4dvEXT(target,v);
}
void APIENTRY smglMultiTexCoord4fEXT(register __d0 GLenum target,
				     register __fp0 GLfloat s,
				     register __fp1 GLfloat t,
				     register __fp2 GLfloat r,
				     register __fp3 GLfloat q)
{
	glMultiTexCoord4fEXT(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4fvEXT(register __d0 GLenum target,
				      register __a0 const GLfloat *v)
{
	glMultiTexCoord4fvEXT(target,v);
}
void APIENTRY smglMultiTexCoord4iEXT(register __d0 GLenum target,
				     register __d1 GLint s,
				     register __d2 GLint t,
				     register __d3 GLint r,
				     register __d4 GLint q)
{
	glMultiTexCoord4iEXT(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4ivEXT(register __d0 GLenum target,
				      register __a0 const GLint *v)
{
	glMultiTexCoord4ivEXT(target,v);
}
void APIENTRY smglMultiTexCoord4sEXT(register __d0 GLenum target,
				     register __d1 GLshort s,
				     register __d2 GLshort t,
				     register __d3 GLshort r,
				     register __d4 GLshort q)
{
	glMultiTexCoord4sEXT(target,s,t,r,q);
}
void APIENTRY smglMultiTexCoord4svEXT(register __d0 GLenum target,
				      register __a0 const GLshort *v)
{
	glMultiTexCoord4svEXT(target,v);
}

void APIENTRY smglInterleavedTextureCoordSetsEXT(register __d0 GLint factor )
{
	glInterleavedTextureCoordSetsEXT(factor);
}

void APIENTRY smglSelectTextureEXT(register __d0 GLenum target )
{
	glSelectTextureEXT(target);
}

void APIENTRY smglSelectTextureCoordSetEXT(register __d0 GLenum target )
{
	glSelectTextureCoordSetEXT(target);
}

void APIENTRY smglSelectTextureTransformEXT(register __d0 GLenum target )
{
	glSelectTextureTransformEXT(target);
}

/* GL_EXT_point_parameters */
void APIENTRY smglPointParameterfEXT( register __d0 GLenum pname,
					   register __fp0 GLfloat param )
{
	glPointParameterfEXT(pname,param);
}
void APIENTRY smglPointParameterfvEXT( register __d0 GLenum pname,
					    register __a0 const GLfloat *params )
{
	glPointParameterfvEXT(pname,params);
}



/*
 * GL_MESA_window_pos
 */

void APIENTRY smglWindowPos2iMESA(register __d0 GLint x,
				       register __d1 GLint y )
{
	glWindowPos2iMESA(x,y);
}
void APIENTRY smglWindowPos2sMESA(register __d0 GLshort x,
				       register __d1 GLshort y )
{
	glWindowPos2sMESA(x,y);
}
void APIENTRY smglWindowPos2fMESA(register __fp0 GLfloat x,
				       register __fp1 GLfloat y )
{
	glWindowPos2fMESA(x,y);
}
void APIENTRY smglWindowPos2dMESA(register __fp0 GLdouble x,
				       register __fp1 GLdouble y )
{
	glWindowPos2dMESA(x,y);
}

void APIENTRY smglWindowPos2ivMESA(register __a0 const GLint *p )
{
	glWindowPos2ivMESA(p);
}
void APIENTRY smglWindowPos2svMESA(register __a0 const GLshort *p )
{
	glWindowPos2svMESA(p);
}
void APIENTRY smglWindowPos2fvMESA(register __a0 const GLfloat *p )
{
	glWindowPos2fvMESA(p);
}
void APIENTRY smglWindowPos2dvMESA(register __a0 const GLdouble *p )
{
	glWindowPos2dvMESA(p);
}

void APIENTRY smglWindowPos3iMESA(register __d0 GLint x,
				       register __d1 GLint y,
				       register __d2 GLint z )
{
	glWindowPos3iMESA(x,y,z);
}
void APIENTRY smglWindowPos3sMESA(register __d0 GLshort x,
				       register __d1 GLshort y,
				       register __d2 GLshort z )
{
	glWindowPos3sMESA(x,y,z);
}
void APIENTRY smglWindowPos3fMESA(register __fp0 GLfloat x,
				       register __fp1 GLfloat y,
				       register __fp2 GLfloat z )
{
	glWindowPos3fMESA(x,y,z);
}
void APIENTRY smglWindowPos3dMESA(register __fp0 GLdouble x,
				       register __fp1 GLdouble y,
				       register __fp2 GLdouble z )
{
	glWindowPos3dMESA(x,y,z);
}

void APIENTRY smglWindowPos3ivMESA(register __a0 const GLint *p )
{
	glWindowPos3ivMESA(p);
}
void APIENTRY smglWindowPos3svMESA(register __a0 const GLshort *p )
{
	glWindowPos3svMESA(p);
}
void APIENTRY smglWindowPos3fvMESA(register __a0 const GLfloat *p )
{
	glWindowPos3fvMESA(p);
}
void APIENTRY smglWindowPos3dvMESA(register __a0 const GLdouble *p )
{
	glWindowPos3dvMESA(p);
}

void APIENTRY smglWindowPos4iMESA(register __d0 GLint x,
				       register __d1 GLint y,
				       register __d2 GLint z,
				       register __d3 GLint w )
{
	glWindowPos4iMESA(x,y,z,w);
}
void APIENTRY smglWindowPos4sMESA(register __d0 GLshort x,
				       register __d1 GLshort y,
				       register __d2 GLshort z,
				       register __d3 GLshort w )
{
	glWindowPos4sMESA(x,y,z,w);
}
void APIENTRY smglWindowPos4fMESA(register __fp0 GLfloat x,
				       register __fp1 GLfloat y,
				       register __fp2 GLfloat z,
				       register __fp3 GLfloat w )
{
	glWindowPos4fMESA(x,y,z,w);
}
void APIENTRY smglWindowPos4dMESA(register __fp0 GLdouble x,
				       register __fp1 GLdouble y,
				       register __fp2 GLdouble z,
				       register __fp3 GLdouble w)
{
	glWindowPos4dMESA(x,y,z,w);
}

void APIENTRY smglWindowPos4ivMESA(register __a0 const GLint *p )
{
	glWindowPos4ivMESA(p);
}
void APIENTRY smglWindowPos4svMESA(register __a0 const GLshort *p )
{
	glWindowPos4svMESA(p);
}
void APIENTRY smglWindowPos4fvMESA(register __a0 const GLfloat *p )
{
	glWindowPos4fvMESA(p);
}
void APIENTRY smglWindowPos4dvMESA(register __a0 const GLdouble *p )
{
	glWindowPos4dvMESA(p);
}

/* GL_MESA_resize_buffers */

void APIENTRY smglResizeBuffersMESA()
{
	glResizeBuffersMESA();
}

/* 1.2 functions */

void APIENTRY smglDrawRangeElements(register __d0 GLenum mode,
				    register __d1 GLuint start,
				    register __d2 GLuint end,
				    register __d3 GLsizei count,
				    register __d4 GLenum type,
				    register __a0 const GLvoid *indices )
{
	glDrawRangeElements(mode,start,end,count,type,indices);
}

void APIENTRY smglTexImage3D(register __d0 GLenum target,
			     register __d1 GLint level,
			     register __d2 GLenum internalFormat,
			     register __d3 GLsizei width,
			     register __d4 GLsizei height,
			     register __d5 GLsizei depth,
			     register __d6 GLint border,
			     register __d7 GLenum format,
			     register __a0 GLenum type,
			     register __a1 const GLvoid *pixels )
{
	glTexImage3D(target,level,internalFormat,width,height,depth,border,format,type,pixels);
}

void APIENTRY smglTexSubImage3D(register __d0 GLenum target,
				register __d1 GLint level,
				register __d2 GLint xoffset,
				register __d3 GLint yoffset,
				register __d4 GLint zoffset,
				register __d5 GLsizei width,
				register __d6 GLsizei height,
				register __d7 GLsizei depth,
				register __a0 GLenum format,
				register __a1 GLenum type,
				register __a2 const GLvoid *pixels)
{
	glTexSubImage3D(target,level,xoffset,yoffset,zoffset,width,height,depth,format,type,pixels);
}

void APIENTRY smglCopyTexSubImage3D(register __d0 GLenum target,
				    register __d1 GLint level,
				    register __d2 GLint xoffset,
				    register __d3 GLint yoffset,
				    register __d4 GLint zoffset,
				    register __d5 GLint x,
				    register __d6 GLint y,
				    register __d7 GLsizei width,
				    register __a0 GLsizei height )
{
	glCopyTexSubImage3D(target,level,xoffset,yoffset,zoffset,x,y,width,height );
}
