
		mc68040
		fpu

		XDEF    _gl_sqrt
		XDEF    _gl_sqrt__r

_gl_sqrt__r
_gl_sqrt
		fmove.s 4(sp),fp0
		fsqrt   fp0,fp0
		rts

		XDEF    _fast_exp
		XDEF    _fast_exp__r

_fast_exp
_fast_exp__r
		fmovem.x        fp2/fp3,-(sp)
		fmove.s 4+2*12(sp),fp0          ;fp0 = x
		fmove   fp0,fp2
		fmove.s invln2,fp1
		fmul    fp0,fp1                 ;fp1 = x / ln2
		fmove.l fp1,d0
		fmove.l d0,fp1                  ;fp1 = k = (int)x / ln2
		fmul.s  ln2,fp1
		fsub    fp1,fp2                 ;fp2 = r
		fmove   fp2,fp3
		fmul    fp3,fp3                 ;fp3 = r^2
		fmove.s p2,fp1
		fmul    fp3,fp1
		fadd.s  p1,fp1
		fmul    fp3,fp1
		fmove   fp2,fp0
		fsub    fp1,fp0                 ;fp0 = R1
		fmove.s #2,fp1
		fsub    fp0,fp1
		fmul    fp2,fp0
		fdiv    fp1,fp0
		fadd    fp2,fp0
		fadd.s  #1,fp0                  ;fp0 = exp(r)
		moveq   #20,d1
		asl.l   d1,d0
		add.l   #$3ff00000,d0
		move.l  d0,-8(sp)
		clr.l   -4(sp)
		fmove.d -8(sp),fp1
		fmul    fp1,fp0                 ;fp0 = exp(x)
		fmovem.x        (sp)+,fp2/fp3
		rts


		XDEF    _fast_log
		XDEF    _fast_log__r

_fast_log
_fast_log__r
		fmovem.x        fp2,-(sp)
		fmove.s 4+1*12(sp),fp0          ;fp0 = x
		fmove.s fp0,d0
		move.l  d0,d1
		swap    d0
		lsr.l   #7,d0
		and.l   #$ff,d0
		sub.l   #$7f,d0                 ;d0 = k
		and.l   #$007fffff,d1
		or.l    #$3f800000,d1
		fmove.s d1,fp1                  ;fp1 = 1+f
		fmove   fp1,fp2
		fmove.s #1,fp0
		fadd    fp0,fp2                 ;fp2 = 2+f
		fsub    fp0,fp1                 ;fp1 = f
		fdiv    fp2,fp1
		fmove   fp1,fp2                 ;fp2 = s = f/(2+f)
		fmove   fp2,fp1
		fmul    fp1,fp1                 ;fp1 = s*s
		fmove.s l2,fp0
		fmul    fp1,fp0
		fadd.s  l1,fp0
		fmul    fp1,fp0
		fmul    fp2,fp0
		fadd    fp2,fp0
		fadd    fp2,fp0                 ;fp0 = log(1+f)
		fmove.l d0,fp1                  ;fp1 = k
		fmul.s  ln2,fp1                 ;fp2 = k*ln2
		fadd    fp1,fp0                 ;fp0 = log(x)
		fmovem.x        (sp)+,fp2
		rts


		XDEF    _fast_pow
		XDEF    _fast_pow__r

_fast_pow
_fast_pow__r
		fmove.s 4(sp),fp0          ;fp0 = base
		fmove.s fp0,-(sp)
		bsr     _fast_log
		addq.l  #4,sp
		fmul.s  8(sp),fp0
		fmove.s fp0,-(sp)
		bsr     _fast_exp
		addq.l  #4,sp
		rts


		section data
ln2             dc.s    0.69314718
invln2          dc.s    1.442695042
p1              dc.s    0.1666666667
p2              dc.s    -0.002777777778
l1              dc.s    0.6666666666
l2              dc.s    0.4000000000

